//Start app
Titanium.include('/db/db.js');
Titanium.include('/db/on_launch.js');
var pWidth = Ti.Platform.displayCaps.platformWidth;
var pHeight = Ti.Platform.displayCaps.platformHeight;
if(pWidth > pHeight) {
	pWidth = Ti.Platform.displayCaps.platformHeight;
	pHeight = Ti.Platform.displayCaps.platformWidth;
}
// this sets the background color of the master UIView (when there are no windows/tab groups on it)
Titanium.UI.setBackgroundColor('#878787');
// create base UI tab and root window
var homeWindow = Titanium.UI.createWindow({
	title: 'Home',
	backgroundColor: '#878787',
	backgroundImage: 'images/homebg.png',
	exitOnClose: true,
	navBarHidden: true,
	height: pHeight,
	width: pWidth
});
homeWindow.orientationModes = [Titanium.UI.PORTRAIT];

//create buttons for change locale
var button_active = '';
var button_change_locale_to_ca = Titanium.UI.createView({
	color: '#fff',
	top: 0 + Ti.App.units,
	left: 0,
	height: 50 + Ti.App.units,
	width: pWidth / 3,
	backgroundColor: label_active('ca') ? 'transparent' : '#999'
});
if(label_active('ca')) {
	button_active = button_change_locale_to_ca;
}
var label_catala = Titanium.UI.createLabel({
	color: '#fff',
	text: 'Català',
	font: {
		fontSize: 12 + Ti.App.units,
		fontFamily: 'Arial'
	},
	textAlign: 'center',
	width: 'auto',
	top: 20 + Ti.App.units
});
button_change_locale_to_ca.add(label_catala);

var button_change_locale_to_es = Titanium.UI.createView({
	color: '#fff',
	top: 0 + Ti.App.units,
	left: pWidth / 3,
	height: 50 + Ti.App.units,
	width: pWidth / 3,
	backgroundColor: label_active('es') ? 'transparent' : '#999'
});
if(label_active('es')) {
	button_active = button_change_locale_to_es;
}
var label_castellano = Titanium.UI.createLabel({
	color: '#fff',
	text: 'Castellano',
	font: {
		fontSize: 12 + Ti.App.units,
		fontFamily: 'Arial'
	},
	textAlign: 'center',
	width: 'auto',
	top: 20 + Ti.App.units
});
button_change_locale_to_es.add(label_castellano);

var button_change_locale_to_en = Titanium.UI.createView({
	color: '#fff',
	top: 0 + Ti.App.units,
	left: (pWidth / 3) * 2,
	height: 50 + Ti.App.units,
	width: pWidth / 3,
	backgroundColor: label_active('en') ? 'transparent' : '#999'
});
if(label_active('en')) {
	button_active = button_change_locale_to_en;
}
var label_english = Titanium.UI.createLabel({
	color: '#fff',
	text: 'English',
	font: {
		fontSize: 12 + Ti.App.units,
		fontFamily: 'Arial'
	},
	textAlign: 'center',
	width: 'auto',
	top: 20 + Ti.App.units
});
button_change_locale_to_en.add(label_english);

button_change_locale_to_ca.addEventListener('click', function(e) {
	change_locale('ca', button_change_locale_to_ca);
});
button_change_locale_to_es.addEventListener('click', function(e) {
	change_locale('es', button_change_locale_to_es);
});
button_change_locale_to_en.addEventListener('click', function(e) {
	change_locale('en', button_change_locale_to_en);
});

homeWindow.add(button_change_locale_to_ca);
homeWindow.add(button_change_locale_to_es);
homeWindow.add(button_change_locale_to_en);

function label_active(locale_label) {
	if(locale_label == Ti.App.locale)
		return true;
	return false;
}

function change_locale(str_locale, button_to_change) {
	resetfunction();
	button_to_change.setBackgroundColor('transparent');
	button_active = button_to_change;
	Ti.App.locale = new configLocale().setLocale(str_locale);
	Ti.App.locale = str_locale;
	label_search_by_name.text = L(Ti.App.locale + "_search_by_name").toUpperCase();
	label_search_by_map.text = L(Ti.App.locale + "_search_by_map").toUpperCase();
	label_search_by_list.text = L(Ti.App.locale + "_search_by_list").toUpperCase();
	label_credits.text = L(Ti.App.locale + "_credits");
	label_share.text = L(Ti.App.locale + "_share");
}

function resetfunction() {
	if(button_active != '') button_active.setBackgroundColor('#999');
}

var button_search_by_name = Titanium.UI.createView({
	color: '#fff',
	top: 290 + Ti.App.units,
	left: 40 + Ti.App.units,
	height: 97 + Ti.App.units,
	width: 82 + Ti.App.units,
	backgroundImage: 'images/bg_bt_search_home.png',
	backgroundFocusedImage: 'images/bg_bt_search_home_click.png',
	backgroundSelectedImage: 'images/bg_bt_search_home_click.png'
});
var label_search_by_name = Titanium.UI.createLabel({
	color: '#fff',
	text: L(Ti.App.locale + "_search_by_name").toUpperCase(),
	font: {
		fontSize: 13 + Ti.App.units,
		fontFamily: 'Arial'
	},
	textAlign: 'center',
	top: 65 + Ti.App.units,
	width: 82 + Ti.App.units,
});
button_search_by_name.add(label_search_by_name);

var button_search_by_map = Titanium.UI.createView({
	color: '#fff',
	top: 290 + Ti.App.units,
	left: 130 + Ti.App.units,
	height: 97 + Ti.App.units,
	width: 82 + Ti.App.units,
	backgroundImage: 'images/bg_bt_map_home.png',
	backgroundFocusedImage: 'images/bg_bt_map_home_click.png',
	backgroundSelectedImage: 'images/bg_bt_map_home_click.png'
});
var label_search_by_map = Titanium.UI.createLabel({
	color: '#fff',
	text: L(Ti.App.locale + "_search_by_map").toUpperCase(),
	font: {
		fontSize: 13 + Ti.App.units,
		fontFamily: 'Arial'
	},
	textAlign: 'center',
	top: 65 + Ti.App.units,
	width: 80 + Ti.App.units,
});
button_search_by_map.add(label_search_by_map);

var button_search_by_list = Titanium.UI.createView({
	color: '#fff',
	top: 290 + Ti.App.units,
	left: 220 + Ti.App.units,
	height: 97 + Ti.App.units,
	width: 82 + Ti.App.units,
	backgroundImage: 'images/bg_bt_list_home.png',
	backgroundFocusedImage: 'images/bg_bt_list_home_click.png',
	backgroundSelectedImage: 'images/bg_bt_list_home_click.png'
});
var label_search_by_list = Titanium.UI.createLabel({
	color: '#fff',
	text: L(Ti.App.locale + "_search_by_list").toUpperCase(),
	font: {
		fontSize: 13 + Ti.App.units,
		fontFamily: 'Arial'
	},
	// font:{fontSize:Ti.App.ishigh ? 20 : 13,fontFamily:'Arial'},
	textAlign: 'center',
	top: 65 + Ti.App.units,
	width: 82 + Ti.App.units,
});
button_search_by_list.add(label_search_by_list);

button_search_by_name.addEventListener('click', function(e) {
	var window_search_by_name = Titanium.UI.createWindow({
		id: 'list',
		backgroundColor: '#fff',
		navBarHidden: true,
		url: 'windows/search_by_name.js'
	});
	window_search_by_name.open({
		animated: true
	});
});
button_search_by_map.addEventListener('click', function(e) {
	var window_search_by_map = Titanium.UI.createWindow({
		id: 'list',
		backgroundColor: '#fff',
		navBarHidden: true,
		url: 'windows/search_by_map.js'
	});
	window_search_by_map.open({
		animated: true
	});
});
button_search_by_list.addEventListener('click', function(e) {
	var window_search_by_list = Titanium.UI.createWindow({
		id: 'list',
		backgroundColor: '#fff',
		navBarHidden: true,
		url: 'windows/search_by_list.js'
	});
	window_search_by_list.open({
		animated: true
	});
});

homeWindow.add(button_search_by_name);
homeWindow.add(button_search_by_map);
homeWindow.add(button_search_by_list);

var bottom_bar = Titanium.UI.createView({
	backgroundImage: 'images/home_bg_footer.jpg',
	width: pWidth,
	height: 40 + Ti.App.units,
	bottom: 0 + Ti.App.units
});

var button_credits = Titanium.UI.createView({
	top: 5 + Ti.App.units,
	width: 75 + Ti.App.units,
	right: pWidth / 2,
	backgroundImage: 'images/credits_bg.png'
});
var label_credits = Titanium.UI.createLabel({
	text: L(Ti.App.locale + "_credits"),
	color: '#FFFFFF',
	font: {
		fontSize: 11 + Ti.App.units,
		fontFamily: 'Arial'
	},
	top: 10 + Ti.App.units,
	left: 25 + Ti.App.units
});
button_credits.add(label_credits);
button_credits.addEventListener('click', function(e) {
	var window_credits = Titanium.UI.createWindow({
		backgroundColor: '#fff',
		navBarHidden: true,
		url: 'windows/credits.js'
	});
	window_credits.open({
		animated: true
	});
});
bottom_bar.add(button_credits);

var button_share = Titanium.UI.createView({
	top: 5 + Ti.App.units,
	backgroundImage: 'images/share_bg.png',
	width: 90 + Ti.App.units,
	left: pWidth / 2
});
var label_share = Titanium.UI.createLabel({
	text: L(Ti.App.locale + "_share"),
	color: '#FFFFFF',
	font: {
		fontSize: 11 + Ti.App.units,
		fontFamily: 'Arial'
	},
	top: 10 + Ti.App.units,
	left: 30 + Ti.App.units
});
button_share.add(label_share);

var emailDialog = Ti.UI.createEmailDialog({
	html: true
});

button_share.addEventListener('click', function(e) {
	emailDialog.subject = L(Ti.App.locale + "_share_subj");
	var app_url = 'http://www.mhcat.cat/app';
	switch(Ti.App.locale) {
	case 'es':
		app_url = 'http://www.es.mhcat.cat/app';
		break;
	case 'en':
		app_url = 'http://www.en.mhcat.cat/app';
		break;
	}
	var app_img = 'http://www.mhcat.cat/extension/mhc/design/mhc/images/app/share_icon.png';
	var messagehtmlbody = '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd"><html lang="en"><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8"><meta name="viewport" content="width=50, initial-scale=1.0, user-scalable=yes"></head><body><h2>' + L(Ti.App.locale + "_share_body") + '</h2><a href="'+app_url+'">'+app_url+'</a></body></html>';

	emailDialog.messageBody = messagehtmlbody;
	emailDialog.open();
});

bottom_bar.add(button_share);

homeWindow.add(bottom_bar);

homeWindow.addEventListener('open', loadCheckings);
Titanium.include('/db/update.js');

function loadCheckings() {
	var images_monuments = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory + '/monumentsi');
	if(!images_monuments.exists()) {
		move_images(homeWindow);
	}

	if(Titanium.Network.online) {
		makeremove(homeWindow);
		makeupdate(homeWindow);
	}
}
homeWindow.open();

Ti.App.addEventListener('openLink', function(e) {
	var pat = /^https?:\/\//i;
	if(pat.test(e.url)) {
		Ti.Platform.openURL(e.url);
	} else if(e.url.substring(0, 7) == "mailto:") {
		var emailDialog = Ti.UI.createEmailDialog();
		emailDialog.toRecipients = [e.url.substring(7, e.url.length)];
		emailDialog.open();
	} else {
		Ti.Platform.openURL('http://www.mhcat.cat' + e.url);
	}
});