//Funcion para hacer consultas a la base de datos de monumentos
function ConfigReader()
{
    this.readAvailableMonuments = function()
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var resultSet = db.execute('select * from '+Ti.App.locale+'_monument');
        var result = new Array();

        while (resultSet.isValidRow())
        {
            var row = new Object();
            row["node_id"]=resultSet.fieldByName("node_id");
            row["name"]=resultSet.fieldByName("name");
            result[result.length] = row;
            resultSet.next();
        }
        if( resultSet )
            resultSet.close();
        db.close();
        return result;
    }

    this.readMonumentsForMap = function()
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var resultSet = db.execute('select * from '+Ti.App.locale+'_monument');
        var result = new Array();

        while (resultSet.isValidRow())
        {
            var row = new Object();
            row["node_id"]=resultSet.fieldByName("node_id");
            row["name"]=resultSet.fieldByName("name");
            row["location"]=resultSet.fieldByName("location");
            row["contact"]=resultSet.fieldByName("address");
            result[result.length] = row;
            resultSet.next();
        }
        if( resultSet )
            resultSet.close();
        db.close();
        return result;
    }

    this.doSearch = function(search)
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var resultSet = db.execute('select * from '+Ti.App.locale+'_monument where name like "%'+search+'%"');
        var result = new Array();

        while (resultSet.isValidRow())
        {
            var row = new Object();
            row["node_id"]=resultSet.fieldByName("node_id");
            row["name"]=resultSet.fieldByName("name");
            result[result.length] = row;
            resultSet.next();
        }
        if( resultSet )
            resultSet.close();
        db.close();
        return result;
    }

    this.readMonument = function( node_id )
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var resultSet = db.execute('select * from '+Ti.App.locale+'_monument where node_id='+node_id);
        var row = new Object();
        if (resultSet.isValidRow())
        {
            row["node_id"] = resultSet.fieldByName("node_id");
            row["name"] = resultSet.fieldByName("name");
            row["short_name"] = resultSet.fieldByName("short_name");
            row["description"] = resultSet.fieldByName("description");
            row["times"] = resultSet.fieldByName("times");
            row["prices"] = resultSet.fieldByName("prices");
            row["access"] = resultSet.fieldByName("access");
            row["service"] = resultSet.fieldByName("services");
            row["download"] = resultSet.fieldByName("guide");
            row["contact"] = resultSet.fieldByName("address");
            row["location"] = resultSet.fieldByName("location");
        }
        if( resultSet )
            resultSet.close();
        db.close();
        return row;
    }

    this.readMonumentTypes = function()
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var resultSet = db.execute('select * from monument_type');
        var result = new Array();
        while (resultSet.isValidRow())
        {
            var row = new Object();
            row["name"] = resultSet.fieldByName("name_"+Ti.App.locale);
            row["id"] = resultSet.fieldByName("id");
            result[result.length] = row;
            resultSet.next();
        }
        if( resultSet )
            resultSet.close();
        db.close();
        return result;
    }

    this.readMonumentsByType = function( type )
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var resultSet = db.execute('select * from '+Ti.App.locale+'_monument where monument_type like "%'+type+'%"');
        var result = new Array();
        while (resultSet.isValidRow())
        {
            var row = new Object();
            row["node_id"]=resultSet.fieldByName("node_id");
            row["name"]=resultSet.fieldByName("name");
            result[result.length] = row;
            resultSet.next();
        }
        if( resultSet )
            resultSet.close();
        db.close();
        return result;
    }

    this.readCategoriesMonument = function( node_id )
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var resultSet = db.execute('SELECT * FROM activities_category WHERE monument_id='+node_id+' ORDER BY priority ASC');
        var result = new Array();
        while (resultSet.isValidRow())
        {
            if( resultSet.fieldByName("name_"+Ti.App.locale) != '' && resultSet.fieldByName("name_"+Ti.App.locale) != null )
            {
                var resultSetActivities = db.execute('SELECT * FROM activities WHERE activity_category_id='+resultSet.fieldByName("node_id")+' ORDER BY priority ASC');
                var has_content = false;
                while( resultSetActivities.isValidRow() )
                {
                    if(resultSetActivities.fieldByName("name_"+Ti.App.locale) != '' && resultSetActivities.fieldByName("name_"+Ti.App.locale) != null )
                    {
                        has_content = true;
                    }
                    resultSetActivities.next();
                }
                if( has_content )
                {
                    var row = new Object();
                    row["name"] = resultSet.fieldByName("name_"+Ti.App.locale);
                    row["node_id"] = resultSet.fieldByName("node_id");
                    result[result.length] = row;
                }
            }
            resultSet.next();
        }
        if( resultSet )
            resultSet.close();
        db.close();
        return result;
    }

    this.readAllActivitiesMonument = function( node_id )
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var resultSet = db.execute('SELECT * FROM activities where activity_category_id IN (select node_id from activities_category where monument_id = '+node_id+') ORDER BY priority ASC');
        var result = new Array();
        while (resultSet.isValidRow())
        {
            if(resultSet.fieldByName("name_"+Ti.App.locale) != '' && resultSet.fieldByName("name_"+Ti.App.locale) != null)
            {
                var row = new Object();
                row["name"] = resultSet.fieldByName("name_"+Ti.App.locale);
                row["node_id"] = resultSet.fieldByName("node_id");
                result[result.length] = row;
            }
            resultSet.next();
        }
        if( resultSet )
            resultSet.close();
        db.close();
        return result;
    }

    this.readCategoryActivity = function( activity_id )
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var resultSet = db.execute('SELECT activities_category.name_'+Ti.App.locale+' as name FROM activities_category, activities WHERE activities.node_id = '+activity_id+' AND activities.activity_category_id = activities_category.node_id');
        var row = new Object();
        if (resultSet.isValidRow())
        {
            row["name"] = resultSet.fieldByName("name");
        }
        if( resultSet )
            resultSet.close();
        db.close();
        return row;
    }

    this.readActivitiesCategory = function( activity_category_id )
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var resultSet = db.execute('SELECT * FROM activities WHERE activity_category_id='+activity_category_id+' ORDER BY priority ASC');
        var result = new Array();
        while (resultSet.isValidRow())
        {
            if(resultSet.fieldByName("name_"+Ti.App.locale) != '' && resultSet.fieldByName("name_"+Ti.App.locale) != null )
            {
                var row = new Object();
                row["name"] = resultSet.fieldByName("name_"+Ti.App.locale);
                row["node_id"] = resultSet.fieldByName("node_id");
                result[result.length] = row;
            }
            resultSet.next();
        }
        if( resultSet )
            resultSet.close();
        db.close();
        return result;
    }

    this.readActivity = function( node_id )
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var resultSet = db.execute('SELECT * FROM activities WHERE node_id='+node_id);
        var row = new Object();
        if (resultSet.isValidRow())
        {
            row["node_id"] = resultSet.fieldByName("node_id");
            row["name"] = resultSet.fieldByName("name_"+Ti.App.locale);
            row["tema"] = resultSet.fieldByName("tema_"+Ti.App.locale);
        }
        if( resultSet )
            resultSet.close();
        db.close();
        return row;
    }

    this.readThumbnailsMonument = function( node_id )
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var result = new Array();

        var resultSet = db.execute('select * from images where monument_id='+node_id);
        while (resultSet.isValidRow())
        {
            var row = new Object();
            row["id"] = resultSet.fieldByName("node_id");
            row["path"] = Ti.Filesystem.applicationDataDirectory + 'monumentsi' + Ti.Filesystem.separator + node_id + Ti.Filesystem.separator + 'thumbnail_gallery' + Ti.Filesystem.separator + resultSet.fieldByName("image");
            result[result.length] = row;
            resultSet.next();
        }
        if( resultSet )
            resultSet.close();

        db.close();
        return result;
    }

    this.readImagesMonument = function( node_id )
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var result = new Array();

        var resultSet = db.execute('select * from images where monument_id='+node_id);
        while (resultSet.isValidRow())
        {
            var row = new Object();
            row["node_id"] = resultSet.fieldByName("node_id");
            row["name"] = resultSet.fieldByName("name_"+Ti.App.locale);
            row["image"] = Ti.Filesystem.applicationDataDirectory + 'monumentsi' + Ti.Filesystem.separator + node_id + Ti.Filesystem.separator + 'gallery' + Ti.Filesystem.separator + resultSet.fieldByName("image");
            result[result.length] = row;
            resultSet.next();
        }
        if( resultSet )
            resultSet.close();

        db.close();
        return result;
    }
}

//Funcion para actualizar la base de datos, añadir y eliminar
function configUpdateDB()
{
    this.existMonument = function( node_id , locale_consult )
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var resultSet = db.execute('select * from '+locale_consult+'_monument where node_id='+node_id);
        var exist = false;
        if (resultSet.isValidRow())
        {
            exist = true;
        }
        if( resultSet )
            resultSet.close();
        db.close();
        return exist;
    }

    this.addMonument = function( monument , locale_insert )
    {
        var db = Titanium.Database.open( Ti.App.name_db );

        //insertar el monumento
        db.execute("INSERT INTO "+locale_insert+"_monument ('node_id','name','short_name','times','prices','access','services','guide','address','location','monument_type','description') VALUES (?,?,?,?,?,?,?,?,?,?,?,?)",
        monument.node_id , monument.name , monument.short_name , monument.times , monument.prices , monument.access , monument.services , monument.guide , monument.address , monument.location , monument.monument_type , monument.description);

        //Actividades
        for(var i in monument.category_activity)
        {
            //para cada categoria de actividad comprobar si existe
            var resultSetCheckCatAct = db.execute('SELECT * FROM activities_category WHERE monument_id='+monument.node_id+' AND node_id='+monument.category_activity[i].node_id);
            var exist = false;
            if (resultSetCheckCatAct.isValidRow())
            {
                var tmp_name = monument.category_activity[i].name;
                var priority = monument.category_activity[i].priority;
                tmp_name = tmp_name.replace(/'/gi, "''");
                //existe, se ha de actualizar
                db.execute('UPDATE activities_category SET name_'+locale_insert+'="'+tmp_name+'", priority="'+priority+'" WHERE node_id="'+monument.category_activity[i].node_id+'"');
            }
            else
            {
                //no existe se ha de añadir
                db.execute("INSERT INTO activities_category ('node_id','name_"+locale_insert+"','monument_id','priority') VALUES (?,?,?,?)",
                monument.category_activity[i].node_id , monument.category_activity[i].name , monument.node_id , monument.category_activity[i].priority);
            }

            var activities = monument.category_activity[i].activities;
            for(var c in activities)
            {
                //para cada actividad comprobar si existe
                var resultSetCheckAct = db.execute('SELECT * FROM activities WHERE node_id='+activities[c].node_id);
                var exist = false;
                if (resultSetCheckAct.isValidRow())
                {
                    //existe, se ha de actualizar
                    var act_name_up = activities[c].name;
                    act_name_up = act_name_up.replace(/'/gi, "''");
                    var act_tema_up = activities[c].tema;
                    act_tema_up = act_tema_up.replace(/'/gi, "''");
                    var act_start_date = activities[c].start_date;
                    var act_end_date = activities[c].end_date;

                    db.execute("UPDATE activities SET name_"+locale_insert+"='"+act_name_up+"' , tema_"+locale_insert+"='"+act_tema_up+"' , start_date='"+act_start_date+"' , end_date='"+act_end_date+"' , priority='"+activities[c].priority+"' WHERE node_id='"+activities[c].node_id+"'");
                }
                else
                {
                    //no existe se ha de añadir
                    var act_node_id_up = activities[c].node_id;
                    var act_act_node_id_up = monument.category_activity[i].node_id;
                    var act_name_up = activities[c].name;
                    act_name_up = act_name_up.replace(/'/gi, "''");
                    var act_tema_up = activities[c].tema;
                    act_tema_up = act_tema_up.replace(/'/gi, "''");
                    var act_start_date_up = activities[c].start_date;
                    var act_end_date_up = activities[c].end_date;

                    //var arrayaddact = [ activities[c].node_id , monument.category_activity[i].node_id , activities[c].name , activities[c].tema , activities[c].start_date , activities[c].end_date ];
                    db.execute('INSERT INTO activities ("node_id","activity_category_id","name_'+locale_insert+'","tema_'+locale_insert+'","start_date","end_date","priority") VALUES (\''+act_node_id_up+'\',\''+act_act_node_id_up+'\',\''+act_name_up+'\',\''+act_tema_up+'\',\''+act_start_date_up+'\',\''+act_end_date_up+'\',\''+activities[c].priority+'\')');
                }
            }
        }
        db.close();
    }

    this.deleteMonument = function( monument , locale_delete )
    {
        var db = Titanium.Database.open( Ti.App.name_db );

        //eliminar el monumento
        db.execute("DELETE FROM "+locale_delete+"_monument WHERE node_id='"+monument.node_id+"'");

        //eliminar categorias actividades
        for(var i in monument.category_activity)
        {
            db.execute('UPDATE activities_category SET name_'+locale_delete+'="" WHERE node_id='+monument.category_activity[i].node_id);

            //eliminar actividades
            var activities = monument.category_activity[i].activities;
            for(var c in activities)
            {
                db.execute('UPDATE activities SET name_'+locale_delete+'="" , tema_'+locale_delete+'="" WHERE node_id='+activities[c].node_id);
            }
        }

        db.close();
    }

    this.existImage = function( node_id )
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var resultSet = db.execute('select * from images where node_id='+node_id );
        var exist = false;
        if (resultSet.isValidRow())
        {
            exist = true;
        }
        if( resultSet )
            resultSet.close();
        db.close();
        return exist;
    }

    this.deleteImage = function( node_id )
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        db.execute('DELETE FROM images WHERE node_id='+node_id );
        db.close();
    }

    this.updateImage = function( node_id , image , lang_input )
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var mon_name = image.name;
        var mon_caption = image.caption;
        var mon_image = node_id + "." + image.extension;
        //insertar la imagen
        db.execute('UPDATE images SET caption_'+lang_input+'="'+mon_caption+'", name_'+lang_input+'="'+mon_name+'", image="'+mon_image+'" WHERE node_id="'+node_id+'"' );
        db.close();
    }

    this.addImage = function( node_id , image , lang_input , monument_id )
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        //insertar la imagen
        db.execute("INSERT INTO images ('node_id','caption_"+lang_input+"','name_"+lang_input+"','image','monument_id') VALUES (?,?,?,?,?)",
        node_id , image.caption , image.name , node_id + "." + image.extension , monument_id );
        db.close();
    }

    this.readAllMonuments = function(locale_input)
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var resultSet = db.execute('select * from '+locale_input+'_monument');
        var result = new Array();

        while (resultSet.isValidRow())
        {
            result[result.length] = resultSet.fieldByName("node_id");
            resultSet.next();
        }
        if( resultSet )
            resultSet.close();
        db.close();
        return result;
    }

    this.readAllCategories = function()
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var resultSet = db.execute('select * from activities_category');
        var result = new Array();

        while (resultSet.isValidRow())
        {
            result[result.length] = resultSet.fieldByName("node_id");
            resultSet.next();
        }
        if( resultSet )
            resultSet.close();
        db.close();
        return result;
    }

    this.readAllImages = function()
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var resultSet = db.execute('select * from images');
        var result = new Array();

        while (resultSet.isValidRow())
        {
            result[result.length] = resultSet.fieldByName("node_id");
            resultSet.next();
        }
        if( resultSet )
            resultSet.close();
        db.close();
        return result;
    }

    this.readAllActivities = function()
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var resultSet = db.execute('select * from activities');
        var result = new Array();

        while (resultSet.isValidRow())
        {
            result[result.length] = resultSet.fieldByName("node_id");
            resultSet.next();
        }
        if( resultSet )
            resultSet.close();
        db.close();
        return result;
    }

    //This function remove the monument and categories activities and imatges if it is necessary
    this.removeMonument = function( mon_id , locale_remove )
    {
        mon_id = parseInt(mon_id);
        var db = Titanium.Database.open( Ti.App.name_db );

        db.execute("DELETE FROM "+locale_remove+"_monument WHERE node_id='"+mon_id+"'");

        var langs = ['ca','es','en'];
        var exist = false;
        for(var l in langs)
        {
            var resultSet = db.execute('select * from '+langs[l]+'_monument WHERE node_id='+mon_id);
            if (resultSet.isValidRow()){
                exist = true;
            }
            if( resultSet )
                resultSet.close();
        }
        if(exist == false)
        {
            //eliminar
            var resultSet = db.execute('SELECT node_id FROM activities_category WHERE monument_id='+mon_id);
            while (resultSet.isValidRow())
            {
                var cat_id = resultSet.fieldByName("node_id");
                db.execute('DELETE FROM activities WHERE activity_category_id='+cat_id);
                resultSet.next();
            }
            db.execute('DELETE FROM activities_category WHERE monument_id='+mon_id);
            db.execute('DELETE FROM images WHERE monument_id='+mon_id);
            var appdir = Titanium.Filesystem.getApplicationDataDirectory();
            var images_folder = Titanium.Filesystem.getFile( appdir , 'monumentsi/'+mon_id );
            images_folder.deleteDirectory(true);
            resultSet.close();
        }
        db.close();
    }

    this.removeCategory = function( cat_id , locale_remove )
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        db.execute('UPDATE activities_category SET name_'+locale_remove+'="" WHERE node_id="'+cat_id+'"' );
        db.close();
    }

    this.removeActivity = function( act_id , locale_remove )
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        db.execute('UPDATE activities SET name_'+locale_remove+'="", tema_'+locale_remove+'="" WHERE node_id="'+act_id+'"' );
        db.close();
    }

    this.removeImage = function( img_id , locale_remove )
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        db.execute('UPDATE images SET name_'+locale_remove+'="", caption_'+locale_remove+'="" WHERE node_id="'+img_id+'"' );
        db.close();
    }

    this.clear_empty = function()
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var resultSetActivitiesCat = db.execute( "SELECT node_id FROM activities_category WHERE name_en='' AND name_es='' AND name_ca=''" );
        while (resultSetActivitiesCat.isValidRow())
        {
            var cat_id = resultSetActivitiesCat.fieldByName("node_id");
            db.execute('DELETE FROM activities WHERE activity_category_id='+cat_id);
            resultSetActivitiesCat.next();
        }
        db.execute( "DELETE FROM activities_category WHERE name_en='' AND name_es='' AND name_ca=''" );
        var appdir = Ti.Filesystem.getApplicationDataDirectory();
        var resultSetImages = db.execute( "SELECT image, monument_id FROM images WHERE name_en='' AND name_es='' AND name_ca='' AND caption_en='' AND caption_es='' AND caption_ca=''" );
        while (resultSetImages.isValidRow())
        {
            var mon_id = resultSetImages.fieldByName("monument_id");
            var image_name = resultSetImages.fieldByName("image");

            var img = Titanium.Filesystem.getFile( appdir , 'monumentsi' , mon_id , 'gallery' , image_name );
            if(img.exists()){
                img.deleteFile();
            }

            var thumb_img = Titanium.Filesystem.getFile( appdir , 'monumentsi' , mon_id , 'thumbnail_gallery' , image_name );
            if(thumb_img.exists()){
                thumb_img.deleteFile();
            }
            resultSetImages.next();
        }
        db.execute( "DELETE FROM images WHERE name_en='' AND name_es='' AND name_ca='' AND caption_en='' AND caption_es='' AND caption_ca=''" );

        if( resultSetImages )
            resultSetImages.close();
        db.close();
    }
}

//Funcion para consultar y cambiar el locale de la base de datos
function configLocale()
{
    this.getLocale = function()
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var resultSet = db.execute("SELECT value FROM settings WHERE setting='locale'");
        var locale = resultSet.fieldByName("value");
        if( resultSet )
            resultSet.close();
        db.close();
        return locale;
    }

    this.setLocale = function( locale )
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        db.execute("UPDATE settings SET value='"+locale+"' WHERE setting='locale'");
        db.close();
        return locale;
    }
}

function configUpdates()
{
    this.getLastUpdate = function()
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        var resultSet = db.execute("SELECT value FROM settings WHERE setting='last_update'");
        var last_update = resultSet.fieldByName("value");
        if( resultSet )
            resultSet.close();
        db.close();
        return last_update;
    }

    this.setLastUpdate = function( timetoset )
    {
        var db = Titanium.Database.open( Ti.App.name_db );
        db.execute("UPDATE settings SET value='"+timetoset+"' WHERE setting='last_update'");
        db.close();
        return true;
    }
}

function move_images( curr_window )
{
    Ti.App.fireEvent('checkingUpdates', { identifier: 'move_images' , openClose: 1 , curr_window: curr_window });

    var appdir = Ti.Filesystem.getApplicationDataDirectory();
    var destination_dir = Titanium.Filesystem.getFile( appdir , 'monumentsi');
    destination_dir.createDirectory();

    var resdir = Ti.Filesystem.getResourcesDirectory();
    var source_dir = Titanium.Filesystem.getFile( resdir , 'monumentsi');
    var monuments = source_dir.getDirectoryListing();
    //Ti.API.info(JSON.stringify());
    for(var i in monuments)
    {
        //Ti.API.info(JSON.stringify(monuments[i]));
        var tmp_folder = Titanium.Filesystem.getFile( appdir , 'monumentsi' , monuments[i] );
        tmp_folder.createDirectory();

        var tmp_folder_mon = Titanium.Filesystem.getFile( resdir , 'monumentsi' , monuments[i] );
        var folders_in = tmp_folder_mon.getDirectoryListing();
        for(var m in folders_in)
        {
            var images_dest = Titanium.Filesystem.getFile( appdir , 'monumentsi' , monuments[i] , folders_in[m] );
            images_dest.createDirectory();

            //Ti.API.info(JSON.stringify("   -->"+folders_in[m]));
            var images_tmp = Titanium.Filesystem.getFile( resdir , 'monumentsi' , monuments[i] , folders_in[m] );
            var images_in = images_tmp.getDirectoryListing();

            for(var c in images_in)
            {
                var image_dest = Titanium.Filesystem.getFile( appdir , 'monumentsi' , monuments[i] , folders_in[m] , images_in[c] );
                var image_source = Titanium.Filesystem.getFile( resdir , 'monumentsi' , monuments[i] , folders_in[m] , images_in[c] );
                image_dest.write(image_source.read());

                //Ti.API.info(JSON.stringify("        -->"+images_in[c]));
            }
        }
    }
    Ti.App.fireEvent('checkingUpdates', { identifier: 'move_images' , openClose: 0 });
}
