function makeupdate( curr_window )
{
    Ti.App.fireEvent('checkingUpdates', { identifier: 'makeupdate' , openClose: 1 , curr_window: curr_window });

    var loader = Titanium.Network.createHTTPClient();
    var last_update = new configUpdates().getLastUpdate();

    //Ti.API.info("Start of update on: "+last_update);

    //loader.open("GET","http://10.0.2.2/api/ezx/v1/checkupdates/"+last_update);
    loader.open("GET","http://www.mhcat.cat/api/ezx/v1/checkupdates/"+last_update);
    loader.onload = function(){
        var response = JSON.parse(this.responseText);
        if(response.update == 1)
        {
            var confirm = Titanium.UI.createAlertDialog({
                title: L(Ti.App.locale+"_updates_available"),
                message: String.format( L(Ti.App.locale+'_update_info_size') , response.size ),
                buttonNames: [L(Ti.App.locale+'_yes'), L(Ti.App.locale+'_no')],
                cancel: 1
            });

            confirm.addEventListener('click', function(e)
            {
                var total_size = response.size * 1024;
                var size_downloaded = 0;
                var percent = 0;
                var lang = ['ca','es','en'];

                if (e.index == 0)
                {
                    var updatewindow = Ti.UI.createView({
                        zIndex:1000,
                        backgroundColor:"#000000",
                        opacity:0.8,
                        height:pHeight,
                        width:pWidth
                    });
                    curr_window.add( updatewindow );
                    updatewindow.show();
                    var title = Titanium.UI.createLabel({
                        top: 160,
                        height:40,
                        font:{fontSize:20 + Ti.App.units, fontWeight:'bold'},
                        color:'#FFFFFF',
                        textAlign:'center',
                        text:L(Ti.App.locale+"_updating")
                    });
                    var info = Titanium.UI.createLabel({
                        top: 200,
                        height:30,
                        textAlign:'center',
                        font:{fontSize:15 + Ti.App.units},
                        color:'#FFFFFF'
                    });
                    var percent_label = Titanium.UI.createLabel({
                        top: 245,
                        text:'0 %',
                        height:30,
                        textAlign:'center',
                        font:{fontSize:15 + Ti.App.units},
                        color:'#FFFFFF'
                    });
                    var pb=Titanium.UI.createProgressBar({
                        top: 270,
                        min:0,
                        width:300,
                        height:40,
                        max:total_size,
                        value:0,
                        color:'#FFFFFF',
                        font:{fontSize:14 + Ti.App.units, fontWeight:'bold'}
                    });
                    updatewindow.add(title);
                    updatewindow.add(info);
                    updatewindow.add(percent_label);
                    updatewindow.add(pb);
                    pb.show();
                    updatewindow.addEventListener('android:back', function(){
                        updatewindow.remove(title);
                        updatewindow.remove(info);
                        updatewindow.remove(percent_label);
                        updatewindow.remove(pb);
                        updatewindow.hide();
                        title = null;
                        info = null;
                        percent_label = null;
                        pb = null;
                        updatewindow = null;
                    });

                    for(var i in lang)
                    {
                        if( typeof response.response.monuments != 'undefined' )
                        {
                            var monuments = response.response.monuments[lang[i]];
                            if( typeof monuments != 'undefined' )
                            {
                                info.setText(String.format(L(Ti.App.locale+'_updating_lang_content'),lang[i]));
                                for(var key in monuments)
                                {
                                    var exist = new configUpdateDB().existMonument( monuments[key].node_id , lang[i] );
                                    if(exist){
                                        //Delete monument
                                        var resDelete = new configUpdateDB().deleteMonument( monuments[key] , lang[i] );
                                    }
                                    //Add monument
                                    var resAdd = new configUpdateDB().addMonument(monuments[key] , lang[i]);
                                }
                            }
                        }
                    }
                    size_downloaded += 1024;
                    pb.setValue(size_downloaded);
                    percent = Math.round( (size_downloaded * 100 ) / total_size );
                    percent_label.setText( percent + " %" );
                    if(percent >= 100){
                        info.setText("");
                        title.setText(L(Ti.App.locale+"_finished"));
                        updatewindow.hide();
                    }

                    //Update images
                    info.setText(L(Ti.App.locale+"_updating_images"));
                    var images = response.response.images;
                    var appdir = Ti.Filesystem.getApplicationDataDirectory();

                    for(var i in images)
                    {
                        var folder_monument = Titanium.Filesystem.getFile( appdir , 'monumentsi' , i);

                        if(!folder_monument.exists()){
                            folder_monument.createDirectory();
                        }
                        //background image
                        if( typeof images[i].bg_image != 'undefined' )
                        {
                            info.setText(L(Ti.App.locale+"_updating_bg_images"));
                            //comprobar si existe la carpeta bg_image
                            //si no existe crearla
                            var folder_bg_image = Titanium.Filesystem.getFile( appdir , "monumentsi" , i , "bg_image");
                            if(!folder_bg_image.exists()){
                                folder_bg_image.createDirectory();
                            }

                            //comprobar si existe la imagen
                            //si existe eliminarla
                            var bg_image = Titanium.Filesystem.getFile( appdir , 'monumentsi' , i , 'bg_image' , "bg_image." + images[i].bg_image.extension );
                            if(bg_image.exists()){
                                bg_image.deleteFile();
                            }

                            getRemoteFile( bg_image , images[i].bg_image.url );

                            size_downloaded += images[i].bg_image.size;
                            pb.setValue(size_downloaded);
                            percent = Math.round( (size_downloaded * 100 ) / total_size );
                            percent_label.setText( percent + " %" );
                            if(percent >= 100){
                                info.setText("");
                                title.setText(L(Ti.App.locale+"_finished"));
                                updatewindow.hide();
                                break;
                            }
                        }

                        //gallery
                        //comprobar si existe la carpeta gallery
                        //si no existe crearla
                        var folder_thumbnail_gallery = Titanium.Filesystem.getFile( appdir , "monumentsi" , i , "gallery");
                        if(!folder_thumbnail_gallery.exists()){
                            folder_thumbnail_gallery.createDirectory();
                        }

                        if( typeof images[i].gallery != 'undefined' )
                        {
                            info.setText(L(Ti.App.locale+"_updating_gal_images"));
                            for(var l in lang)
                            {
                                var gal = images[i].gallery[lang[l]];
                                if( typeof gal != 'undefined' )
                                {
                                    for(var img_id in gal)
                                    {
                                        if(lang[l] == 'ca')
                                        {
                                            //comprobar si existe la imagen
                                            //si existe eliminarla
                                            var gal_img = Titanium.Filesystem.getFile( appdir , 'monumentsi' , i , 'gallery' , img_id + "." + gal[img_id].extension );
                                            if(gal_img.exists()){
                                                gal_img.deleteFile();
                                            }

                                            getRemoteFile( gal_img , gal[img_id].url );
                                        }

                                        var exist_img = new configUpdateDB().existImage( img_id );
                                        if(exist_img){
                                            //Update image
                                            var update_img = new configUpdateDB().updateImage( img_id , gal[img_id] , lang[l] );
                                        }
                                        else{
                                            //Add image
                                            var add_img = new configUpdateDB().addImage( img_id , gal[img_id] , lang[l] , i );
                                        }

                                        size_downloaded += gal[img_id].size;
                                        pb.setValue(size_downloaded);
                                        percent = Math.round( (size_downloaded * 100 ) / total_size );
                                        percent_label.setText( percent + " %" );
                                        if(percent >= 100){
                                            info.setText("");
                                            title.setText(L(Ti.App.locale+"_finished"));
                                            updatewindow.hide();
                                            break;
                                        }
                                    }
                                }
                            }
                        }

                        //thumbnails
                        //comprobar si existe la carpeta thumbnail_gallery
                        //si no existe crearla
                        var folder_thumbnail_gallery = Titanium.Filesystem.getFile( appdir , "monumentsi" , i , "thumbnail_gallery");
                        if(!folder_thumbnail_gallery.exists()){
                            folder_thumbnail_gallery.createDirectory();
                        }

                        if( typeof images[i].thumbnail_gallery != 'undefined' )
                        {
                            info.setText(L(Ti.App.locale+"_updating_thumb_images"));
                            for(var l in lang)
                            {
                                var thumb_gal = images[i].thumbnail_gallery[lang[l]];
                                if( typeof thumb_gal != 'undefined' )
                                {
                                    for(var img_id in thumb_gal)
                                    {
                                        if(lang[l] == 'ca')
                                        {
                                            //comprobar si existe la imagen
                                            //si existe eliminarla
                                            var thumb_img = Titanium.Filesystem.getFile( appdir , 'monumentsi' , i , 'thumbnail_gallery' , img_id + "." + thumb_gal[img_id].extension );
                                            if(thumb_img.exists()){
                                                thumb_img.deleteFile();
                                            }

                                            getRemoteFile( thumb_img , thumb_gal[img_id].url );
                                        }

                                        size_downloaded += thumb_gal[img_id].size;
                                        pb.setValue(size_downloaded);
                                        percent = Math.round( (size_downloaded * 100 ) / total_size );
                                        percent_label.setText( percent + " %" );
                                        if(percent >= 100){
                                            info.setText("");
                                            title.setText(L(Ti.App.locale+"_finished"));
                                            updatewindow.hide();
                                            break;
                                        }
                                    }
                                }
                            }
                        }
                    }
                    var setting_date = new configUpdates().setLastUpdate( response.date );
                }
            });
            confirm.show();
        }
        Ti.App.fireEvent('checkingUpdates', { identifier: 'makeupdate' , openClose: 0 });
    };
    loader.send();
}

function getRemoteFile( local_file , url )
{
    var c = Titanium.Network.createHTTPClient();
    c.onload = function(){
        if (c.status == 200 ){
            local_file.write(this.responseData);
        }
    };
    c.open('GET' , url , false);
    c.send();
}

function makeremove( curr_window )
{
    Ti.App.fireEvent('checkingUpdates', { identifier: 'makeremove' , openClose: 1 , curr_window: curr_window });

    var loader = Titanium.Network.createHTTPClient();

    //loader.open("GET","http://10.0.2.2/api/ezx/v1/checkremoves");
    loader.open("GET","http://www.mhcat.cat/api/ezx/v1/checkremoves");
    loader.onload = function()
    {
        var allcategories = new configUpdateDB().readAllCategories();
        var allactivities = new configUpdateDB().readAllActivities();
        var allimages = new configUpdateDB().readAllImages();

        var response = JSON.parse(this.responseText);
        response = response.response;

        for(var lang in response)
        {
            //Ti.API.info("lang: "+lang);
            var allmonuments = new configUpdateDB().readAllMonuments(lang);
            var mon_to_remove = array_diff( allmonuments , response[lang].monuments );

            //Ti.API.info("allmonuments: "+allmonuments);
            //Ti.API.info("response[lang].monuments: "+response[lang].monuments);
            //Ti.API.info("mon_to_remove: "+mon_to_remove);

            for(var i in mon_to_remove)
            {
                var res_remove = new configUpdateDB().removeMonument( mon_to_remove[i] , lang );
            }

            var cat_to_remove = array_diff( allcategories , response[lang].categories_activity );

            //Ti.API.info("allcategories: "+allcategories);
            //Ti.API.info("response[lang].categories_activity: "+response[lang].categories_activity);
            //Ti.API.info("cat_to_remove: "+cat_to_remove);

            for(var i in cat_to_remove)
            {
                var res_remove = new configUpdateDB().removeCategory( cat_to_remove[i] , lang );
            }

            var act_to_remove = array_diff( allactivities , response[lang].activities );

            //Ti.API.info("allactivities: "+allactivities);
            //Ti.API.info("response[lang].activities: "+response[lang].activities);
            //Ti.API.info("act_to_remove: "+act_to_remove);

            for(var i in act_to_remove)
            {
                var res_remove = new configUpdateDB().removeActivity( act_to_remove[i] , lang );
            }

            var img_to_remove = array_diff( allimages , response[lang].images );

            //Ti.API.info("allimages: "+allimages);
            //Ti.API.info("response[lang].images: "+response[lang].images);
            //Ti.API.info("img_to_remove: "+img_to_remove);

            for(var i in img_to_remove)
            {
                var res_remove = new configUpdateDB().removeImage( img_to_remove[i] , lang );
            }

            //var mon_to_add = array_diff( response[lang].monuments , allmonuments );
            //Titanium.API.info("EEEEEEEEAKI:");
            ///////////////////////////////////////////////////
            //Titanium.API.info(JSON.stringify(mon_to_add)); //
            ///////////////////////////////////////////////////
        }
        Ti.App.fireEvent('checkingUpdates', { identifier: 'makeremove' , openClose: 0 });
    };
    loader.send();

    var clear_empty = new configUpdateDB().clear_empty();
}
function array_diff (arr1, arr2)
{
    var retArr = [];
    var contain = false;
    for(var i in arr1)
    {
        contain = false;
        for(var c in arr2)
        {
            //Ti.API.info("check if: "+arr2[c]+" == "+arr1[i]);
            if(arr2[c] == arr1[i])
                contain = true;
        }
        if(contain == false)
            retArr[retArr.length] = arr1[i];
    }
    return retArr;
}