Titanium.include('/db/db.js');

var w = Titanium.UI.currentWindow;
var node_id = w.eventparam;
var monument = new ConfigReader().readMonument(node_id);
var initial_list = [];

w.orientationModes = [Titanium.UI.PORTRAIT];

w.setBackgroundColor('#fff');

var height_row = 40;
switch(Titanium.Platform.displayCaps.density) {
case 'normal':
	height_row = 40;
	break;
case 'high':
	height_row = 60;
	break;
case 'xhigh':
	height_row = 80;
	break;
}

var categories = new ConfigReader().readCategoriesMonument(node_id);

if(categories.length) initial_list = new ConfigReader().readActivitiesCategory(categories[0].node_id);

var all_list = new ConfigReader().readAllActivitiesMonument(node_id);

var data = [];
for(var i = 0; i < initial_list.length; i++) {
	data[i] = {
		title: initial_list[i].name,
		node_id: initial_list[i].node_id,
		color: '#000',
		selectedColor: '#fff',
		hasChild: true,
		font: {
			fontSize: 15 + Ti.App.units
		},
		height: height_row
	}
}

var all_data = [];
for(var i = 0; i < all_list.length; i++) {
	all_data[i] = {
		title: all_list[i].name,
		node_id: all_list[i].node_id,
		color: '#000',
		selectedColor: '#fff',
		hasChild: true,
		font: {
			fontSize: 15 + Ti.App.units
		},
		height: height_row
	}
}

//Start TOP-BAR
var topbar = Titanium.UI.createView({
	backgroundColor: '#000',
	backgroundImage: '/images/bg_header.gif',
	top: 0 + Ti.App.units,
	width: '100%',
	height: 36 + Ti.App.units
});
var logo_mhcat = Titanium.UI.createImageView({
	image: '/images/logo_mhcat.png',
	height: 24 + Ti.App.units,
	width: 24 + Ti.App.units,
	top: 5 + Ti.App.units,
	left: 5 + Ti.App.units
});

var title = Titanium.UI.createLabel({
	color: '#FFF',
	text: monument.short_name,
	font: {
		fontSize: 14 + Ti.App.units,
		fontFamily: 'Arial'
	},
	left: 34 + Ti.App.units
});
topbar.add(logo_mhcat);
topbar.add(title);
w.add(topbar);
//End TOP-BAR
//Start Top-Content
var button_close = Titanium.UI.createButton({
	height: 31 + Ti.App.units,
	width: 32 + Ti.App.units,
	backgroundImage: '/images/bt_close.png',
	top: 40 + Ti.App.units,
	right: 2 + Ti.App.units
});
button_close.addEventListener('click', function(e) {
	closewindow();
});
w.add(button_close);
var title_activities = Titanium.UI.createLabel({
	color: '#000',
	text: L(Ti.App.locale + '_act_title'),
	font: {
		fontSize: 16 + Ti.App.units,
		fontFamily: 'Arial'
	},
	top: 50 + Ti.App.units,
	left: 10 + Ti.App.units
});
w.add(title_activities);
//End Top-Content
//Start Categories-Buttons
var top_buttons = Titanium.UI.createView({
	top: 80 + Ti.App.units,
	height: 41 + Ti.App.units
});

var left = 10;
for(var i = 0; i < categories.length; i++) {
	var cat_button = Titanium.UI.createView({
		backgroundColor: '#000',
		backgroundImage: '/images/bg_menu_item.png',
		top: 0 + Ti.App.units,
		left: left + Ti.App.units,
		width: 80 + Ti.App.units,
		height: 41 + Ti.App.units,
		cat_name: categories[i].name,
		node_id: categories[i].node_id
	});
	top_buttons.add(cat_button);
	var color_lbl = '#000000';
	if(i == 0) color_lbl = '#FF0000';

	var label_button = Titanium.UI.createLabel({
		color: color_lbl,
		text: categories[i].name,
		font: {
			fontSize: 11 + Ti.App.units,
			fontFamily: 'Arial'
		},
		textAlign: 'center',
		width: 70 + Ti.App.units,
		top: 5 + Ti.App.units,
		cat_name: categories[i].name,
		node_id: categories[i].node_id
	});
	cat_button.add(label_button);

	cat_button.addEventListener('click', function(e) {

		clearlabels(this);
		if(this.children[0].color == '#FF0000') {
			this.children[0].color = '#000000';
			tableview.setData(all_data);
		} else {
			var new_list = new ConfigReader().readActivitiesCategory(e.source.node_id);
			this.children[0].color = '#FF0000';
			var new_data = [];
			for(var i = 0; i < new_list.length; i++) {
				new_data[i] = {
					title: new_list[i].name,
					node_id: new_list[i].node_id,
					color: '#000',
					selectedColor: '#fff',
					hasChild: true,
					font: {
						fontSize: 15 + Ti.App.units
					},
					height: height_row
				}
			}
			tableview.setData(new_data);
		}
	});

	left = left + 73;

	if(i < categories.length - 1) {
		var right_bar = Titanium.UI.createView({
			backgroundColor: '#999',
			width: 1 + Ti.App.units,
			top: 80 + Ti.App.units,
			height: 41 + Ti.App.units,
			left: left + Ti.App.units,
		});
		w.add(right_bar);
		left = left + 2;
	}
}
w.add(top_buttons);
//End Categories-Buttons

function clearlabels(label_selected) {
	for(var i = 0; i < top_buttons.children.length; i++) {
		if(label_selected.children[0].node_id != top_buttons.children[i].children[0].node_id) top_buttons.children[i].children[0].color = "#000000";
	}
}

var tableview = Titanium.UI.createTableView({
	data: data,
	top: 130 + Ti.App.units,
	backgroundColor: '#fff'
});
w.add(tableview);
tableview.addEventListener('click', function(e) {
	createWindow(e);
});

function createWindow(e) {
	var activity_detail = Ti.UI.createWindow({
		url: '/windows/activity_detail.js',
		backgroundColor: '#fff',
		navBarHidden: true,
		act_id: e.rowData.node_id,
		mon_id: node_id
	});
	activity_detail.open({
		animated: true
	});
}
w.addEventListener('android:back', function() {
	closewindow();
});

function closewindow() {
	w.close();
	topbar.remove(logo_mhcat);
	topbar.remove(title);
	w.remove(topbar);
	w.remove(title_activities);
	categories = null;
	initial_list = null;
	data = null;
	w.remove(tableview);
	logo_mhcat = null;
	title = null;
	topbar = null;
	title_activities = null;
	tableview = null;
	w = null;
}