Titanium.include('/db/db.js');

var w = Titanium.UI.currentWindow;
var mon_id = w.mon_id;
var act_id = w.act_id;
var monument = new ConfigReader().readMonument(mon_id);
var activity = new ConfigReader().readActivity(act_id);
var activity_category = new ConfigReader().readCategoryActivity(act_id);

//Set dimensions of window
var pWidth = Ti.Platform.displayCaps.platformWidth;
var pHeight = Ti.Platform.displayCaps.platformHeight;
if(pWidth > pHeight) {
	pWidth = Ti.Platform.displayCaps.platformHeight;
	pHeight = Ti.Platform.displayCaps.platformWidth;
}

w.orientationModes = [Titanium.UI.PORTRAIT];

//Start TOP-BAR
var topbar = Titanium.UI.createView({
	backgroundColor: '#000',
	backgroundImage: '/images/bg_header.gif',
	top: 0 + Ti.App.units,
	width: '100%',
	height: 36 + Ti.App.units
});
var logo_mhcat = Titanium.UI.createImageView({
	image: '/images/logo_mhcat.png',
	height: 24 + Ti.App.units,
	width: 24 + Ti.App.units,
	top: 5 + Ti.App.units,
	left: 5 + Ti.App.units
});

var title = Titanium.UI.createLabel({
	color: '#FFF',
	text: monument.short_name,
	font: {
		fontSize: 14 + Ti.App.units,
		fontFamily: 'Arial'
	},
	left: 34 + Ti.App.units
});
topbar.add(logo_mhcat);
topbar.add(title);
w.add(topbar);
//End TOP-BAR
//Start TOP-CONTENT
var button_close = Titanium.UI.createButton({
	height: 31 + Ti.App.units,
	width: 32 + Ti.App.units,
	backgroundImage: '/images/bt_close.png',
	top: 40 + Ti.App.units,
	right: 2 + Ti.App.units,
	zIndex:1000
});
button_close.addEventListener('click', function(e) {
	w.close();
	button_close = null;
	activity_category = null;
	w = null;
});
w.add(button_close);
var activity_category = Titanium.UI.createLabel({
	color: '#FF0000',
	text: activity_category.name,
	font: {
		fontSize: 12 + Ti.App.units,
		fontFamily: 'Arial'
	},
	top: 50 + Ti.App.units,
	left: 15 + Ti.App.units
});
w.add(activity_category);
//End TOP-CONTENT
//Start CONTENT
var activity_tema = activity.tema;
activity_tema = activity_tema.replace(/<img src=\"\//gi, "<img src=\"http://www.mhcat.cat/");
activity_tema = activity_tema.replace(/<a /gi, "<a onclick=\"Ti.App.fireEvent('openLink', { url: this.getAttribute('href')});return false;\" ");
activity_tema = '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd"><html lang="en"> <head> <meta http-equiv="Content-Type" content="text/html; charset=utf-8"><meta name="viewport" content="width=50, initial-scale=1.0, user-scalable=yes"></head><body style="font-family:Arial;margin-top:0px;"><h1 style="margin-top:0px; width:90%; font-size:18px;">' + activity.name + '</h1>' + activity_tema + '</body> </html>';

var box_content_html = Titanium.UI.createWebView({
	color: '#000',
	left: 5 + Ti.App.units,
	html: activity_tema,
	top: 70 + Ti.App.units,
	scalesPageToFit: false,
	enableZoomControls: false,
	width: pWidth - 10
});
w.add(box_content_html);
//End Content
w.addEventListener('android:back', function() {
	closewindow();
});

function closewindow() {
	w.close();
	monument = null;
	activity = null;
	topbar.remove(logo_mhcat);
	topbar.remove(title);
	w.remove(topbar);
	w.remove(button_close);
	w.remove(activity_category);
	w.remove(box_content_html);
	logo_mhcat = null;
	title = null;
	topbar = null;
	button_close = null;
	activity_category = null;
	box_content_html = null;
	w = null;
}