Titanium.include('/db/db.js');

var w = Titanium.UI.currentWindow;
var node_id = w.eventparam;
var monument = new ConfigReader().readMonument(node_id);

w.setBackgroundColor('#999999');

var button_active = '';

w.orientationModes = [Titanium.UI.PORTRAIT];

//Set dimensions of window
var pWidth = Ti.Platform.displayCaps.platformWidth;
var pHeight = Ti.Platform.displayCaps.platformHeight;
if(pWidth > pHeight) {
	pWidth = Ti.Platform.displayCaps.platformHeight;
	pHeight = Ti.Platform.displayCaps.platformWidth;
}

//Start TOP-BAR
var topbar = Titanium.UI.createView({
	backgroundColor: '#000',
	backgroundImage: '/images/bg_header.gif',
	top: 0 + Ti.App.units,
	width: pWidth,
	height: 36 + Ti.App.units
});
var logo_mhcat = Titanium.UI.createImageView({
	image: '/images/logo_mhcat.png',
	height: 24 + Ti.App.units,
	width: 24 + Ti.App.units,
	top: 5 + Ti.App.units,
	left: 5 + Ti.App.units
});

var title = Titanium.UI.createLabel({
	color: '#FFF',
	text: monument.short_name,
	font: {
		fontSize: 14 + Ti.App.units,
		fontFamily: 'Arial'
	},
	left: 34 + Ti.App.units
});
topbar.add(logo_mhcat);
topbar.add(title);
w.add(topbar);
//End TOP-BAR
//Start content scrollview
var GeneralscrollView = Titanium.UI.createScrollView({
	borderRadius: 0,
	contentWidth: pWidth * 2,
	contentHeight: pHeight - 36,
	top: 36 + Ti.App.units,
	left: 0 + Ti.App.units,
	width: pWidth,
	height: pHeight - 36,
	showVerticalScrollIndicator: true,
	showHorizontalScrollIndicator: true
});

var dirFullPath = Ti.Filesystem.applicationDataDirectory + 'monumentsi' + Ti.Filesystem.separator + node_id + Ti.Filesystem.separator + 'bg_image';
var dir = Ti.Filesystem.getFile(dirFullPath);

var dirItems = dir.getDirectoryListing();

for(var i = 0; i < dirItems.length; i++) {
	var itemFullPath = Ti.Filesystem.applicationDataDirectory + 'monumentsi/' + node_id + '/bg_image/' + dirItems[i].toString();
}

var bg_image = Titanium.UI.createView({
	top: 0 + Ti.App.units,
	left: 0 + Ti.App.units,
	width: pWidth * 2,
	backgroundImage: itemFullPath
});
GeneralscrollView.add(bg_image);

//End view for background image
//Start first view
//Start TOP-BUTTONS
var top_buttons = Titanium.UI.createView({
	color: '#000',
	top: 14 + Ti.App.units,
	left: 5 + Ti.App.units,
	width: 120 + Ti.App.units,
	height: 41 + Ti.App.units,
	backgroundImage: '/images/bg_bt_up.png'
});

var button_contact = Titanium.UI.createView({
	height: 41 + Ti.App.units,
	width: 60 + Ti.App.units,
	left: 0 + Ti.App.units
});

var label_contact = Titanium.UI.createLabel({
	color: '#ECECEC',
	text: L(Ti.App.locale + "_contact"),
	font: {
		fontSize: 10 + Ti.App.units,
		fontFamily: 'Arial'
	},
	textAlign: 'center',
	width: '90%',
	height: 36 + Ti.App.units,
	top: 3 + Ti.App.units,
	left: 5 + Ti.App.units,
	activeBackground: '/images/bg_bt_up_active.png',
	defaultBackground: 'transparent'
});

var button_ubi_map = Titanium.UI.createView({
	height: 41 + Ti.App.units,
	width: 60 + Ti.App.units,
	left: 60 + Ti.App.units
});
var label_ubi_map = Titanium.UI.createLabel({
	color: '#ECECEC',
	text: L(Ti.App.locale + "_ubi_map"),
	font: {
		fontSize: 11 + Ti.App.units,
		fontFamily: 'Arial'
	},
	textAlign: 'center',
	width: '90%',
	top: 5 + Ti.App.units
});
button_contact.add(label_contact);
button_ubi_map.add(label_ubi_map);
top_buttons.add(button_contact);
top_buttons.add(button_ubi_map);
bg_image.add(top_buttons);
//End TOP-BUTTONS

//Start Right-Button
var left_more = pWidth - 32;
switch(Titanium.Platform.displayCaps.density) {
case 'normal':
	left_more = pWidth - 32;
	break;
case 'high':
	left_more = pWidth - 67;
	break;
case 'xhigh':
	left_more = pWidth - 85;
	break;
}
var button_more = Titanium.UI.createView({
	color: '#000',
	top: 14 + Ti.App.units,
	left: left_more,
	width: 47 + Ti.App.units,
	height: 57 + Ti.App.units,
	backgroundImage: '/images/bt_more.png'
});
bg_image.add(button_more);
//End Right-Button
button_more.addEventListener('click', function() {
	var offset = 0;
	var init = setInterval(function(e) {
		if(offset >= pWidth) {
			clearInterval(init);
		}
		offset = offset + 100;
		GeneralscrollView.scrollTo(offset, 0);
	}, 1);
});

//Start LEFT-BUTTONS
var left_left_buttons = 5;
var width_left_buttons = 60;
var left_buttons = Titanium.UI.createView({
	color: '#000',
	top: 64 + Ti.App.units,
	left: left_left_buttons + Ti.App.units,
	width: width_left_buttons + Ti.App.units,
	height: 262 + Ti.App.units,
	backgroundImage: '/images/bg_controls_vertical.png'
});
bg_image.add(left_buttons);

var button_timetable = Titanium.UI.createView({
	width: 52 + Ti.App.units,
	height: 48 + Ti.App.units,
	left: 4 + Ti.App.units,
	top: 4 + Ti.App.units,
	backgroundImage: '/images/bg_bt_timetable.png',
	defaultBackground: '/images/bg_bt_timetable.png',
	activeBackground: '/images/bg_bt_timetable_active.png'
});
var label_timetable = Titanium.UI.createLabel({
	color: '#ECECEC',
	text: L(Ti.App.locale + "_time"),
	font: {
		fontSize: 11 + Ti.App.units,
		fontFamily: 'Arial'
	},
	textAlign: 'center',
	width: '100%',
	top: 28 + Ti.App.units
});
button_timetable.add(label_timetable);

var button_prices = Titanium.UI.createView({
	width: 52 + Ti.App.units,
	height: 48 + Ti.App.units,
	left: 4 + Ti.App.units,
	top: 55 + Ti.App.units,
	backgroundImage: '/images/bg_bt_price.png',
	defaultBackground: '/images/bg_bt_price.png',
	activeBackground: '/images/bg_bt_price_active.png'
});
var label_prices = Titanium.UI.createLabel({
	color: '#ECECEC',
	text: L(Ti.App.locale + "_prices"),
	font: {
		fontSize: 11 + Ti.App.units,
		fontFamily: 'Arial'
	},
	textAlign: 'center',
	width: '90%',
	top: 28 + Ti.App.units
});
button_prices.add(label_prices);

var button_access = Titanium.UI.createView({
	width: 52 + Ti.App.units,
	height: 48 + Ti.App.units,
	left: 4 + Ti.App.units,
	top: 107 + Ti.App.units,
	backgroundImage: '/images/bg_bt_access.png',
	defaultBackground: '/images/bg_bt_access.png',
	activeBackground: '/images/bg_bt_access_active.png'
});
var label_access = Titanium.UI.createLabel({
	color: '#ECECEC',
	text: L(Ti.App.locale + "_access"),
	font: {
		fontSize: 11 + Ti.App.units,
		fontFamily: 'Arial'
	},
	textAlign: 'center',
	width: '90%',
	top: 28 + Ti.App.units
});
button_access.add(label_access);

var button_service = Titanium.UI.createView({
	width: 52 + Ti.App.units,
	height: 48 + Ti.App.units,
	left: 4 + Ti.App.units,
	top: 159 + Ti.App.units,
	backgroundImage: '/images/bg_bt_service.png',
	defaultBackground: '/images/bg_bt_service.png',
	activeBackground: '/images/bg_bt_service_active.png'
});
var label_service = Titanium.UI.createLabel({
	color: '#ECECEC',
	text: L(Ti.App.locale + "_serv"),
	font: {
		fontSize: 11 + Ti.App.units,
		fontFamily: 'Arial'
	},
	textAlign: 'center',
	width: '90%',
	top: 28 + Ti.App.units
});
button_service.add(label_service);

var button_description = Titanium.UI.createView({
	width: 52 + Ti.App.units,
	height: 48 + Ti.App.units,
	left: 4 + Ti.App.units,
	top: 211 + Ti.App.units,
	backgroundImage: '/images/bg_bt_guide.png',
	defaultBackground: '/images/bg_bt_guide.png',
	activeBackground: '/images/bg_bt_guide_active.png'
});
var label_what = Titanium.UI.createLabel({
	color: '#ECECEC',
	text: L(Ti.App.locale + "_what"),
	font: {
		fontSize: 11 + Ti.App.units,
		fontFamily: 'Arial'
	},
	textAlign: 'center',
	width: '90%',
	top: 22 + Ti.App.units
});
var label_find = Titanium.UI.createLabel({
	color: '#ECECEC',
	text: L(Ti.App.locale + "_find"),
	font: {
		fontSize: 11 + Ti.App.units,
		fontFamily: 'Arial'
	},
	textAlign: 'center',
	width: 'auto',
	top: 33 + Ti.App.units
});
button_description.add(label_what);
button_description.add(label_find);

left_buttons.add(button_timetable);
left_buttons.add(button_prices);
left_buttons.add(button_access);
left_buttons.add(button_service);
left_buttons.add(button_description);
//End LEFT-BUTTONS
//Start Actions of Buttons
var width_content = 250;
var heigh_content = 420;
switch(Titanium.Platform.displayCaps.density) {
case 'normal':
	heigh_content = 420;
	break;
case 'high':
	heigh_content = 370;
	break;
case 'xhigh':
	heigh_content = 420;
	break;
}
var box_content = Titanium.UI.createView({
	width: width_content + Ti.App.units,
	height: heigh_content + Ti.App.units,
	left: left_left_buttons + width_left_buttons + Ti.App.units,
	top: left_buttons.top,
	opacity: 0.9,
	borderRadius: 10,
	backgroundColor: '#E2E2E2'
});
var box_content_title = Titanium.UI.createLabel({
	color: '#000',
	left: 10 + Ti.App.units,
	width: 'auto',
	font: {
		fontSize: 20 + Ti.App.units,
		fontFamily: 'Arial',
		fontWeight: 'bold'
	},
	textAlign: 'left',
	height: 24 + Ti.App.units,
	top: 10 + Ti.App.units
});
var box_content_html = Titanium.UI.createWebView({
	color: '#000',
	backgroundColor: 'transparent',
	left: 0 + Ti.App.units,
	font: {
		fontSize: 10 + Ti.App.units,
		fontFamily: 'Arial'
	},
	width: width_content - 20 + Ti.App.units,
	height: heigh_content - 80 + Ti.App.units,
	top: 40 + Ti.App.units,
	scalesPageToFit: false,
	enableZoomControls: false
});
var button_close = Titanium.UI.createButton({
	height: 31 + Ti.App.units,
	width: 32 + Ti.App.units,
	backgroundImage: '/images/bt_close.png',
	top: 2 + Ti.App.units,
	right: 2 + Ti.App.units
});
button_close.addEventListener('click', function(e) {
	resetfunction();
});

button_ubi_map.addEventListener('click', function(e) {
	var detailbymap = Ti.UI.createWindow({
		url: '/windows/detail_by_map.js',
		backgroundColor: '#fff',
		navBarHidden: true,
		monument: monument
	});
	detailbymap.open();
});
label_contact.addEventListener('click', function(e) {
	setContent(label_contact, label_contact.text, monument.contact);
});
button_timetable.addEventListener('click', function(e) {
	setContent(button_timetable, label_timetable.text, monument.times);
});
button_prices.addEventListener('click', function(e) {
	setContent(button_prices, label_prices.text, monument.prices);
});
button_access.addEventListener('click', function(e) {
	setContent(button_access, L(Ti.App.locale + '_access_complet'), monument.access);
});
button_service.addEventListener('click', function(e) {
	setContent(button_service, label_service.text, monument.service);
});
button_description.addEventListener('click', function(e) {
	setContent(button_description, label_what.text + " " + label_find.text, monument.description);
});
//End Actions of Buttons
//End first view
//Start Second view
//Start Top-Button
var left_downloads = pWidth + 2;
switch(Titanium.Platform.displayCaps.density) {
case 'normal':
	left_downloads = pWidth + 2;
	width_content = width_content + 80;
	break;
case 'high':
	left_downloads = pWidth + 2;
	width_content = width_content + 50;
	break;
case 'xhigh':
	left_downloads = pWidth + 8;
	width_content = width_content + 80;
	break;
default:
	width_content = width_content + 80;
	break;
}
var button_downloads = Titanium.UI.createView({
	color: '#000',
	top: 14 + Ti.App.units,
	left: left_downloads,
	width: 107 + Ti.App.units,
	height: 41 + Ti.App.units,
	backgroundImage: '/images/bt_what.png'
});
var label_downloads = Titanium.UI.createLabel({
	color: '#ECECEC',
	text: L(Ti.App.locale + "_downloads"),
	font: {
		fontSize: 11 + Ti.App.units,
		fontFamily: 'Arial'
	},
	textAlign: 'center',
	width: '90%',
	top: 12 + Ti.App.units
});
button_downloads.add(label_downloads);
bg_image.add(button_downloads);
button_downloads.addEventListener('click', function(e) {
	button_downloads.setBackgroundImage('/images/bt_what_active.png');
	second_box_content.show();
});
//End Top-Button
//Start second box content
var second_box_content = Titanium.UI.createView({
	width: width_content + Ti.App.units,
	height: heigh_content + Ti.App.units,
	left: pWidth + 20,
	top: 55 + Ti.App.units,
	opacity: 0.9,
	borderRadius: 10,
	backgroundColor: '#E2E2E2'
});
var second_box_content_title = Titanium.UI.createLabel({
	color: '#000',
	left: 10 + Ti.App.units,
	text: L(Ti.App.locale + "_downloads"),
	width: width_content - 20 + Ti.App.units,
	textAlign: 'left',
	top: 10 + Ti.App.units
});

var arrow_image = 'file:///android_asset/Resources/images/downarrow.png';

var downloads_content = monument.download;
downloads_content = downloads_content.replace(/<img src=\"\//gi, "<img src=\"http://www.mhcat.cat/");
downloads_content = downloads_content.replace(/<a /gi, "<a onclick=\"Ti.App.fireEvent('openLink', { url: this.getAttribute('href')});return false;\" ");
downloads_content = '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd"><html lang="en"><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8"><meta name="viewport" content="width=50, initial-scale=1.0, user-scalable=yes"><style>body{font-size:12px;font-family:arial;}li{width:160px;} a{background-image:url("' + arrow_image + '"); background-repeat:no-repeat; background-position: 250px 5px; background-size: 25px; display:block; width:93%; padding:10px; padding-right:45px; background-color:#FFFFFF; text-decoration:none; color:#000000;border-bottom:1px solid #CCC;}p{margin:0px;padding:0px;} br{display:none;}</style></head><body>' + downloads_content + '</body> </html>';

var second_box_content_html = Titanium.UI.createWebView({
	html: downloads_content,
	backgroundColor: 'transparent',
	width: width_content - 20 + Ti.App.units,
	height: heigh_content - 80 + Ti.App.units,
	left: 5 + Ti.App.units,
	top: 38 + Ti.App.units,
	scalesPageToFit: false,
	enableZoomControls: false
});

var second_button_close = Titanium.UI.createButton({
	height: 31 + Ti.App.units,
	width: 32 + Ti.App.units,
	backgroundImage: '/images/bt_close.png',
	top: 2 + Ti.App.units,
	right: 2 + Ti.App.units
});
second_button_close.addEventListener('click', function(e) {
	second_box_content.hide();
	button_downloads.setBackgroundImage('/images/bt_what.png');
});
second_box_content.add(second_box_content_title);
second_box_content.add(second_box_content_html);
second_box_content.add(second_button_close);
//End box content
//Start LEFT-BUTTONS

var left_right_buttons = pWidth + 10;
switch(Titanium.Platform.displayCaps.density) {
case 'normal':
	left_right_buttons = pWidth + 10;
	break;
case 'high':
	left_right_buttons = pWidth + 37;
	break;
case 'xhigh':
	left_right_buttons = pWidth + 37;
	break;
}

var button_activities = Titanium.UI.createView({
	width: 61 + Ti.App.units,
	height: 57 + Ti.App.units,
	left: left_right_buttons,
	top: 64 + Ti.App.units,
	backgroundImage: '/images/bg_bt_activities.png',
	defaultBackground: '/images/bg_bt_activities.png',
	activeBackground: '/images/bg_bt_activities.png'
});
var label_activities = Titanium.UI.createLabel({
	color: '#ECECEC',
	text: L(Ti.App.locale + "_act"),
	font: {
		fontSize: 10 + Ti.App.units,
		fontFamily: 'Arial'
	},
	textAlign: 'center',
	width: '95%',
	top: 35 + Ti.App.units
});
button_activities.add(label_activities);

var button_gallery = Titanium.UI.createView({
	width: 61 + Ti.App.units,
	height: 57 + Ti.App.units,
	left: left_right_buttons,
	top: 133 + Ti.App.units,
	backgroundImage: '/images/bg_bt_gallery.png',
	defaultBackground: '/images/bg_bt_gallery.png',
	activeBackground: '/images/bg_bt_gallery_active.png'
});
var label_gallery = Titanium.UI.createLabel({
	color: '#ECECEC',
	text: L(Ti.App.locale + "_gallery"),
	font: {
		fontSize: 11 + Ti.App.units,
		fontFamily: 'Arial'
	},
	textAlign: 'center',
	width: '90%',
	top: 35 + Ti.App.units
});
button_gallery.add(label_gallery);

button_activities.addEventListener('click', function(e) {
	var activities_list = Titanium.UI.createWindow({
		url: '/windows/activities_list.js',
		backgroundColor: '#fff',
		navBarHidden: true,
		eventparam: monument.node_id
	});
	activities_list.open({
		animated: true
	});
});
button_gallery.addEventListener('click', function(e) {
	var gallery_list = Titanium.UI.createWindow({
		url: '/windows/gallery_list.js',
		backgroundColor: '#000',
		navBarHidden: true,
		monument: monument
	});
	gallery_list.open({
		animated: true
	});
});
//End LEFT-BUTTONS
//End Second view
//Start BACK-BUTTON
var button_back = Titanium.UI.createView({
	color: '#fff',
	bottom: 5 + Ti.App.units,
	left: 5 + Ti.App.units,
	height: 28 + Ti.App.units,
	width: 60 + Ti.App.units,
	backgroundImage: '/images/bg_bt_back.png'
});
var label_back_black = Titanium.UI.createLabel({
	color: '#000',
	text: L(Ti.App.locale + "_back"),
	font: {
		fontSize: 11 + Ti.App.units,
		fontFamily: 'Arial'
	},
	textAlign: 'center',
	width: 50 + Ti.App.units,
	left: 10 + Ti.App.units,
	top: 4 + Ti.App.units
});
var label_back = Titanium.UI.createLabel({
	color: '#fff',
	text: L(Ti.App.locale + "_back"),
	font: {
		fontSize: 11 + Ti.App.units,
		fontFamily: 'Arial'
	},
	textAlign: 'center',
	width: 50 + Ti.App.units,
	left: 10 + Ti.App.units,
	top: 5 + Ti.App.units
});
button_back.add(label_back_black);
button_back.add(label_back);
button_back.addEventListener('click', function(e) {
	closewindow();
});
//End BACK-BUTTON
setTimeout(function() {
	var offset = 0;
	var init = setInterval(function(e) {
		if(-(pWidth) >= offset) {
			clearInterval(init);
		}
		offset = offset - 100;
		GeneralscrollView.scrollTo(offset, 0);
	}, 1);
}, 1000);

w.addEventListener('android:back', function() {
	closewindow();
});

function setContent(buttonC, labelC, contentC) {
	resetfunction();
	button_active = buttonC;
	button_active.setBackgroundImage(button_active.activeBackground);
	contentC = contentC.replace(/<img src=\"\//gi, "<img src=\"http://www.mhcat.cat/");
	contentC = contentC.replace(/<a /gi, "<a onclick=\"Ti.App.fireEvent('openLink', { url: this.getAttribute('href')});return false;\" ");
	contentC = '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd"><html lang="en"> <head> <meta http-equiv="Content-Type" content="text/html; charset=utf-8"><meta name="viewport" content="width=50, initial-scale=1.0, user-scalable=yes"><style>body{font-size:12px;font-family:arial;}li{width:160px;}</style></head><body>' + contentC + '</body> </html>';
	box_content_html.html = contentC;
	box_content_title.setText(labelC);
	box_content.show();
}

function resetfunction() {
	if(button_active != '') {
		button_active.setBackgroundImage(button_active.defaultBackground);
		box_content.hide();
		box_content_html.html = '';
		box_content_title.text = '';
	}
}

function closewindow() {
	w.close({
		animated: true
	});
	topbar.remove(logo_mhcat);
	topbar.remove(title);
	bg_image.remove(topbar);
	logo_mhcat = null;
	title = null;
	topbar = null;
	dirFullPath = null;
	dir = null;
	dirItems = null;
	button_contact.remove(label_contact);
	button_ubi_map.remove(label_ubi_map);
	top_buttons.remove(button_contact);
	top_buttons.remove(button_ubi_map);
	bg_image.remove(top_buttons);
	label_contact = null;
	label_ubi_map = null;
	button_contact = null;
	button_ubi_map = null;
	top_buttons = null;
	bg_image.remove(button_more);
	button_more = null;
	button_timetable.remove(label_timetable);
	label_timetable = null;
	button_prices.remove(label_prices);
	label_prices = null;
	button_access.remove(label_access);
	label_access = null;
	button_service.remove(label_service);
	label_service = null;
	button_description.remove(label_what);
	button_description.remove(label_find);
	label_what = null;
	label_find = null;
	left_buttons.remove(button_timetable);
	left_buttons.remove(button_prices);
	left_buttons.remove(button_access);
	left_buttons.remove(button_service);
	left_buttons.remove(button_description);
	button_timetable = null;
	button_prices = null;
	button_access = null;
	button_service = null;
	button_description = null;
	bg_image.remove(left_buttons);
	left_buttons = null;
	bg_image.remove(box_content);
	box_content.remove(box_content_title);
	box_content.remove(box_content_html);
	box_content.remove(button_close);
	box_content = null;
	box_content_title = null;
	box_content_html = null;
	scrollView = null;
	button_close = null;
	button_back.remove(label_back);
	label_back = null;
	w.remove(button_back);
	button_back = null;
	button_downloads.remove(label_downloads);
	bg_image.remove(button_downloads);
	second_box_content.remove(second_box_content_title);
	second_box_content.remove(second_box_content_html);
	second_box_content.remove(second_button_close);
	second_box_content = null;
	second_button_close = null;
	w.remove(GeneralscrollView);
	bg_image = null;
	GeneralscrollView = null;
	w = null;
}

w.add(GeneralscrollView);

w.add(button_back);

bg_image.add(button_activities);
bg_image.add(button_gallery);

bg_image.add(second_box_content);
second_box_content.hide();

bg_image.add(box_content);
box_content.add(box_content_title);
box_content.add(box_content_html);
box_content.add(button_close);
box_content.hide();