Titanium.include('/db/db.js');

var w = Titanium.UI.currentWindow;
var monument = w.monument;

//Set dimensions of window
var pWidth = Ti.Platform.displayCaps.platformWidth;
var pHeight = Ti.Platform.displayCaps.platformHeight;
if(pWidth > pHeight) {
	pWidth = Ti.Platform.displayCaps.platformHeight;
	pHeight = Ti.Platform.displayCaps.platformWidth;
}

w.setBackgroundColor('#fff');
w.setTitle(monument.name);

w.orientationModes = [
Titanium.UI.PORTRAIT];

//Start TOP-BAR
var topbar = Titanium.UI.createView({
	backgroundColor: '#000',
	backgroundImage: '/images/bg_header.gif',
	top: 0 + Ti.App.units,
	width: pWidth,
	height: 36 + Ti.App.units
});
var logo_mhcat = Titanium.UI.createImageView({
	image: '/images/logo_mhcat.png',
	height: 24 + Ti.App.units,
	width: 24 + Ti.App.units,
	top: 5 + Ti.App.units,
	left: 5 + Ti.App.units
});

var title = Titanium.UI.createLabel({
	color: '#FFF',
	text: monument.short_name,
	font: {
		fontSize: 14 + Ti.App.units,
		fontFamily: 'Arial'
	},
	left: 34 + Ti.App.units
});
var button_close = Titanium.UI.createButton({
	height: 31 + Ti.App.units,
	width: 32 + Ti.App.units,
	backgroundImage: '/images/bt_close.png',
	top: 2 + Ti.App.units,
	right: 0 + Ti.App.units
});

topbar.add(logo_mhcat);
topbar.add(title);
topbar.add(button_close);

w.add(topbar);
button_close.addEventListener('click', function(e) {
	closewindow();
});
//End TOP-BAR
//Start MAP
// CREATE ANNOTATIONS
var bubble = Ti.UI.createView({
	width: 200 + Ti.App.units
});
var myLbl = Ti.UI.createLabel({
	text: monument.name,
	left: 5 + Ti.App.units,
	height: 'auto',
	width: 200 + Ti.App.units,
	color: 'white',
	top: 5 + Ti.App.units,
	font: {
		fontSize: 16 + Ti.App.units,
		fontFamily: 'Arial'
	}
});

var lbl_img = myLbl.toImage();

var gotomon = Ti.UI.createView({
	right: 1 + Ti.App.units,
	myid: monument.node_id,
	width: 31 + Ti.App.units,
	height: 32 + Ti.App.units,
	backgroundImage: '/images/rightandroidbutton.png'
});
gotomon.addEventListener('click', function(e) {
	closewindow();
});

var button_arrive = Ti.UI.createView({
	title: 'button_arrive',
	width: 108 + Ti.App.units,
	height: 20 + Ti.App.units,
	top: lbl_img.height + 10 + Ti.App.units,
	left: 5 + Ti.App.units,
	myid: monument.node_id,
	backgroundImage: '/images/bg_info_button_small.png'
});
location = monument.location.split(',');
var label_arrive = Ti.UI.createLabel({
	text: L(Ti.App.locale + '_how_arrive'),
	latitude: location[0],
	longitude: location[1],
	color: 'white',
	top: 1 + Ti.App.units,
	myid: monument.node_id,
	font: {
		fontSize: 12 + Ti.App.units,
		fontFamily: 'Arial'
	}
});

var bottom_space = Ti.UI.createView({
	width: 10 + Ti.App.units,
	height: 10 + Ti.App.units,
	top: lbl_img.height + 25 + Ti.App.units,
	right: 5 + Ti.App.units
});

button_arrive.add(label_arrive);
bubble.add(myLbl);
bubble.add(gotomon);
bubble.add(button_arrive);
bubble.add(bottom_space);

var ico_image = 'ico_map_point_blue.png';
switch(Titanium.Platform.displayCaps.density) {
case 'normal':
	ico_image = 'ico_map_point_blue.png';
	break;
case 'high':
	ico_image = 'ico_map_point_blue_big.png';
	break;
case 'xhigh':
	ico_image = 'ico_map_point_blue_big.png';
	break;
}

var annotation = Titanium.Map.createAnnotation({
	latitude: location[0],
	longitude: location[1],
	leftView: bubble,
	image: '/images/' + ico_image,
	myid: monument.node_id
});

// CREATE MAP VIEW
var mapview = Titanium.Map.createView({
	mapType: Titanium.Map.STANDARD_TYPE,
	animate: true,
	regionFit: true,
	userLocation: true,
	annotations: [annotation],
	top: 36 + Ti.App.units
});
w.add(mapview);

var delta = 2;
var latitude_u = 41.564601;
var longitude_u = 2.014618;

Titanium.Geolocation.accuracy = Titanium.Geolocation.ACCURACY_HIGH;
Titanium.Geolocation.distanceFilter = 10;
Titanium.Geolocation.getCurrentPosition(function(e) {
	if(e.error) {
		latitude_u = 41.564601;
		longitude_u = 2.014618;
	} else {
		latitude_u = e.coords.latitude;
		longitude_u = e.coords.longitude;
	}

	var poiCenter = {};

	poiCenter.lat = latitude_u - parseFloat((latitude_u - location[0]) / 2);
	poiCenter.lon = longitude_u - parseFloat((longitude_u - location[1]) / 2);

	latitudedelta = Math.abs(latitude_u - location[0]);
	longitudedelta = Math.abs(longitude_u - location[1]);

	delta = Math.max(latitudedelta, longitudedelta);

	var region = {
		latitude: poiCenter.lat,
		longitude: poiCenter.lon,
		latitudeDelta: delta,
		longitudeDelta: delta
	};

	mapview.region = region;

});

label_arrive.addEventListener('click', function(e) {
	var url = "http://maps.google.com/maps?daddr=" + latitude_u + "," + longitude_u + "&saddr=" + label_arrive.latitude + "," + label_arrive.longitude;
	Ti.Platform.openURL(url);
});

myLbl.addEventListener('click', function(e) {
	closewindow();
});
//End MAP
w.addEventListener('android:back', function() {
	closewindow();
});

function closewindow() {
	w.close({
		animated: true
	});
	topbar.remove(logo_mhcat);
	topbar.remove(title);
	topbar.remove(button_close);
	w.remove(topbar);
	w.remove(mapview);
	mapview = null;
	topbar = null;
	annotations = null;
	logo_mhcat = null;
	title = null;
	button_close = null;
	w = null;
}