Titanium.include('/db/db.js');

var w = Titanium.UI.currentWindow;
var image_id = w.image_id;
var imageCount = w.imageCount;
var imagesArray = new ConfigReader().readImagesMonument(w.monument.node_id);

w.orientationModes = [Titanium.UI.LANDSCAPE_LEFT, Titanium.UI.LANDSCAPE_RIGHT];

//Set dimensions of window
var pWidth = Ti.Platform.displayCaps.platformWidth;
var pHeight = Ti.Platform.displayCaps.platformHeight;
if(pWidth > pHeight) {
	pWidth = Ti.Platform.displayCaps.platformHeight;
	pHeight = Ti.Platform.displayCaps.platformWidth;
}

//Start TOP-BAR
var topbar = Titanium.UI.createView({
	backgroundColor: '#000',
	backgroundImage: '/images/bg_header.gif',
	top: 0 + Ti.App.units,
	width: '100%',
	height: 36 + Ti.App.units
});
var logo_mhcat = Titanium.UI.createImageView({
	image: '/images/logo_mhcat.png',
	height: 24 + Ti.App.units,
	width: 24 + Ti.App.units,
	top: 5 + Ti.App.units,
	left: 5 + Ti.App.units
});
var title = Titanium.UI.createLabel({
	color: '#FFF',
	text: w.monument.short_name,
	font: {
		fontSize: 14 + Ti.App.units,
		fontFamily: 'Arial'
	},
	left: 34 + Ti.App.units
});
topbar.add(logo_mhcat);
topbar.add(title);
//End TOP-BAR
//Start images
var selected_image = 0;
var images_array = [];
var image_left = 5;
for(i = 0; i < imagesArray.length; i++) {
	Ti.API.info(imagesArray[i].image);
	var gal_img = Titanium.Filesystem.getFile(imagesArray[i].image);
	if(gal_img.exists()) {
		var image_gal = Titanium.UI.createImageView({
			left: image_left + Ti.App.units,
			width: pHeight,
			image: imagesArray[i].image
		});
		var imgzoomWrapper = Ti.UI.createScrollView({
			maxZoomScale: 4.0,
		});
		imgzoomWrapper.add(image_gal);
		var imgWrapper = Ti.UI.createView();
		imgWrapper.add(image_gal);

		var bottom_bar = Titanium.UI.createView({
			backgroundColor: '#000',
			opacity: '0.7',
			bottom: 0 + Ti.App.units,
			left: image_left - 5 + Ti.App.units,
			width: pHeight,
			height: 40 + Ti.App.units
		});
		var label_bar = Titanium.UI.createLabel({
			color: '#fff',
			text: imagesArray[i].name,
			font: {
				fontSize: 15 + Ti.App.units,
				fontFamily: 'Arial'
			},
			textAlign: 'center'
		});
		bottom_bar.add(label_bar);

		imgWrapper.add(bottom_bar);
		images_array.push(imgWrapper);
	}
}
var GeneralscrollView = Titanium.UI.createScrollableView({
	showPagingControl: false,
	views: images_array,
	currentPage: imageCount
});
w.add(GeneralscrollView);
//End images
//Start TOP BUTTONS
var button_close = Titanium.UI.createButton({
	height: 31 + Ti.App.units,
	width: 32 + Ti.App.units,
	backgroundImage: '/images/bt_close.png',
	top: 40 + Ti.App.units,
	right: 2 + Ti.App.units
});
button_close.addEventListener('click', function(e) {
	closewindow();
});
w.add(button_close);
//End TOP BUTTONS
w.add(topbar);

//End Button Bar
//Start BOTTOM BUTTONS
var top_buttons_gal = pHeight - 62;
var left_button_gal = pWidth - 40;

var next_button = Titanium.UI.createView({
	height: 35 + Ti.App.units,
	width: 32 + Ti.App.units,
	backgroundImage: '/images/bt_next_gal.png',
	bottom: 2 + Ti.App.units,
	right: 2 + Ti.App.units
});
next_button.addEventListener('click', function(e) {
	change_image('next');
});
w.add(next_button);
if(imageCount == imagesArray.length) {
	next_button.hide();
}
var left_button_previous = Ti.App.ishigh ? 120 : 100;
var previous_button = Titanium.UI.createView({
	height: 35 + Ti.App.units,
	width: 32 + Ti.App.units,
	backgroundImage: '/images/bt_back_gal.png',
	bottom: 2 + Ti.App.units,
	left: 2 + Ti.App.units
});
previous_button.addEventListener('click', function(e) {
	change_image('previous');
});
w.add(previous_button);
if(imageCount == 0) {
	previous_button.hide();
}
//END BOTTOM BUTTONS
w.addEventListener('android:back', function() {
	closewindow();
});

GeneralscrollView.addEventListener('scroll', function(e) {
	imageCount = e.currentPage;
	if(imageCount == 0) {
		previous_button.hide();
	}
	if(imageCount == imagesArray.length - 2) {
		next_button.show();
	}
	if(imageCount == imagesArray.length - 1) {
		next_button.hide();
	}
	if(imageCount == 1) {
		previous_button.show();
	}
});

function change_image(direction) {
	switch(direction) {
	case 'previous':
		if(imageCount > 0) {
			imageCount = imageCount - 1;
			GeneralscrollView.setCurrentPage(imageCount);
		}
		if(imageCount == 0) {
			previous_button.hide();
		}
		if(imageCount == imagesArray.length - 2) {
			next_button.show();
		}
		break;
	case 'next':
		if(imageCount < imagesArray.length - 1) {
			imageCount = imageCount + 1;
			GeneralscrollView.setCurrentPage(imageCount);
		}
		if(imageCount == imagesArray.length - 1) {
			next_button.hide();
		}
		if(imageCount == 1) {
			previous_button.show();
		}
		break;
	}
}

function closewindow() {
	w.close({
		animated: true
	});
	GeneralscrollView = null;
	w = null;
}