Titanium.include('/db/db.js');

var w = Titanium.UI.currentWindow;
var monument = w.monument;
var node_id = w.monument.node_id;
var imagesArray = new ConfigReader().readThumbnailsMonument(node_id);

w.orientationModes = [Titanium.UI.PORTRAIT];

//Start TOP-BAR
var topbar = Titanium.UI.createView({
	backgroundColor: '#000',
	backgroundImage: '/images/bg_header.gif',
	top: 0 + Ti.App.units,
	width: '100%',
	height: 36 + Ti.App.units
});
var logo_mhcat = Titanium.UI.createImageView({
	image: '/images/logo_mhcat.png',
	height: 24 + Ti.App.units,
	width: 24 + Ti.App.units,
	top: 5 + Ti.App.units,
	left: 5 + Ti.App.units
});

var title = Titanium.UI.createLabel({
	color: '#FFF',
	text: monument.short_name,
	font: {
		fontSize: 14 + Ti.App.units,
		fontFamily: 'Arial'
	},
	left: 34 + Ti.App.units
});
topbar.add(logo_mhcat);
topbar.add(title);
w.add(topbar);
//End TOP-BAR
//Start Top-Content
var button_close = Titanium.UI.createButton({
	height: 31 + Ti.App.units,
	width: 32 + Ti.App.units,
	backgroundImage: '/images/bt_close.png',
	top: 40 + Ti.App.units,
	right: 2 + Ti.App.units
});
button_close.addEventListener('click', function(e) {
	closewindow();
});
w.add(button_close);
var title_gallery = Titanium.UI.createLabel({
	color: '#FFF',
	text: L(Ti.App.locale + '_gallery_images'),
	font: {
		fontSize: 16 + Ti.App.units,
		fontFamily: 'Arial'
	},
	top: Ti.App.ishigh ? 42 + Ti.App.units : 50 + Ti.App.units,
	left: 10 + Ti.App.units
});
w.add(title_gallery);
//End Top-Content
//Start Gallery
var gallery = Titanium.UI.createScrollView({
	contentWidth: 'auto',
	contentHeight: 'auto',
	top: 80 + Ti.App.units,
	left: 6 + Ti.App.units,
	scrollType: 'vertical',
	showVerticalScrollIndicator: true
});

var top = -100;
var left = 0;
var img_count = 0;
for(var i = 0; i < imagesArray.length; i++) {
	var thumb_img = Titanium.Filesystem.getFile(imagesArray[i]['path']);
	if(thumb_img.exists()) {
		if(esPar(img_count + 1)) {
			left = 160;
		} else {
			left = 0;
			top = top + 100;
		}
		var thumbImage = Titanium.UI.createImageView({
			image: imagesArray[i]['path'],
			imageId: imagesArray[i]['id'],
			imageCount: i,
			width: 145 + Ti.App.units,
			height: 'auto',
			top: top + Ti.App.units,
			left: left + Ti.App.units
		});
		gallery.add(thumbImage);
		thumbImage.addEventListener('click', function(e) {
			var gallery_detail = Titanium.UI.createWindow({
				url: '/windows/gallery_detail.js',
				backgroundColor: '#000',
				navBarHidden: true,
				monument: monument,
				imageCount: e.source.imageCount,
				image_id: e.source.imageId
			});
			gallery_detail.open();
		});
		img_count = img_count + 1;
	}
}
w.add(gallery);
//End Gallery
//Start BACK-BUTTON
var button_back = Titanium.UI.createView({
	color: '#fff',
	bottom: 5 + Ti.App.units,
	left: 5 + Ti.App.units,
	height: 28 + Ti.App.units,
	width: 60 + Ti.App.units,
	backgroundImage: '/images/bg_bt_back.png'
});
var label_back_black = Titanium.UI.createLabel({
	color: '#000',
	text: L(Ti.App.locale + "_back"),
	font: {
		fontSize: 11 + Ti.App.units,
		fontFamily: 'Arial'
	},
	textAlign: 'center',
	width: 50 + Ti.App.units,
	left: 10 + Ti.App.units,
	top: 4 + Ti.App.units
});
var label_back = Titanium.UI.createLabel({
	color: '#fff',
	text: L(Ti.App.locale + "_back"),
	font: {
		fontSize: 11 + Ti.App.units,
		fontFamily: 'Arial'
	},
	textAlign: 'center',
	width: 50 + Ti.App.units,
	left: 10 + Ti.App.units,
	top: 5 + Ti.App.units
});
button_back.add(label_back_black);
button_back.add(label_back);
button_back.addEventListener('click', function(e) {
	closewindow();
});

w.add(button_back);
//End BACK-BUTTON

w.addEventListener('android:back', function() {
	closewindow();
});

function esPar(num) {
	var resto;
	resto = num % 2;
	if(resto == 0) return true;
	else return false;
}

function closewindow() {
	w.close({
		animate: true
	});
	monument = null;
	imagesArray = null;
	topbar.remove(logo_mhcat);
	topbar.remove(title);
	w.remove(topbar);
	logo_mhcat = null;
	title = null;
	topbar = null;
	w.remove(title_gallery);
	w.remove(button_close);
	title_gallery = null;
	button_close = null;
	w.remove(gallery);
	gallery = null;
	thumbImage = null;
	w.remove(button_back);
	button_back = null;
	w = null;
}