Titanium.include('/db/db.js');

var w = Titanium.UI.currentWindow;

w.setBackgroundColor('#fff');
w.setTitle(L(Ti.App.locale + "_search_by_list"));

w.orientationModes = [Titanium.UI.PORTRAIT];

var height_row = 40;
switch(Titanium.Platform.displayCaps.density) {
case 'normal':
	height_row = 40;
	break;
case 'high':
	height_row = 60;
	break;
case 'xhigh':
	height_row = 80;
	break;
}

var result = new ConfigReader().readAvailableMonuments();
var data = [];
for(var i = 0; i < result.length; i++) {
	data[i] = {
		title: result[i].name,
		node_id: result[i].node_id,
		color: '#000',
		selectedColor: '#fff',
		hasChild: true,
		font: {
			fontSize: 15 + Ti.App.units
		},
		height: height_row
	}
}

//Start TOP-Content
var button_close = Titanium.UI.createButton({
	height: 31 + Ti.App.units,
	width: 32 + Ti.App.units,
	backgroundImage: '/images/bt_close.png',
	top: 2 + Ti.App.units,
	right: 2 + Ti.App.units
});
button_close.addEventListener('click', function(e) {
	closewindow();
});
w.add(button_close);
var title = Titanium.UI.createLabel({
	color: '#000',
	text: L(Ti.App.locale + '_mhc_list_monuments'),
	font: {
		fontSize: 16 + Ti.App.units,
		fontFamily: 'Arial'
	},
	top: 10 + Ti.App.units,
	left: 10 + Ti.App.units
});
w.add(title);
var subtitle = Titanium.UI.createLabel({
	color: '#000',
	text: L(Ti.App.locale + '_search_monument_by_type'),
	font: {
		fontSize: 10 + Ti.App.units,
		fontFamily: 'Arial'
	},
	top: Ti.App.ishigh ? 35 + Ti.App.units : 30 + Ti.App.units,
	left: 10 + Ti.App.units
});
w.add(subtitle);
//End TOP-Content
//Start Top Filter Buttons
var monument_types = new ConfigReader().readMonumentTypes();

var top_buttons = Titanium.UI.createView({
	top: 60 + Ti.App.units,
	height: 41 + Ti.App.units
});

var left = 10;
for(var i = 0; i < monument_types.length; i++) {
	var cat_button = Titanium.UI.createView({
		backgroundColor: '#000',
		backgroundImage: '/images/bg_menu_item.png',
		top: 0 + Ti.App.units,
		left: left + Ti.App.units,
		width: 73 + Ti.App.units,
		height: 41 + Ti.App.units,
		cat_name: monument_types[i].name,
		node_id: monument_types[i].id
	});
	top_buttons.add(cat_button);

	if(monument_types[i].name.length > 10) {
		var tmp_top = 5 + Ti.App.units;
	} else {
		if(Ti.App.ishigh) {
			var tmp_top = 12 + Ti.App.units;
		} else {
			var tmp_top = 10 + Ti.App.units;
		}
	}

	var label_button = Titanium.UI.createLabel({
		color: '#000000',
		text: monument_types[i].name,
		font: {
			fontSize: 11 + Ti.App.units,
			fontFamily: 'Arial'
		},
		textAlign: 'center',
		width: 73 + Ti.App.units,
		top: tmp_top,
		cat_name: monument_types[i].name,
		node_id: monument_types[i].id
	});
	cat_button.add(label_button);

	cat_button.addEventListener('click', function(e) {
		clearlabels(this);
		if(this.children[0].color == '#FF0000') {
			this.children[0].color = '#000000';
			tableview.setData(data);
		} else {
			var new_list = new ConfigReader().readMonumentsByType(e.source.node_id);
			this.children[0].color = '#FF0000';
			var new_data = [];
			for(var i = 0; i < new_list.length; i++) {
				new_data[i] = {
					title: new_list[i].name,
					node_id: new_list[i].node_id,
					color: '#000',
					selectedColor: '#fff',
					hasChild: true,
					font: {
						fontSize: 15 + Ti.App.units
					},
					height: 80
				}
			}
			tableview.setData(new_data);
		}
	});

	left = left + 73;

	if(i < monument_types.length - 1) {
		var right_bar = Titanium.UI.createView({
			backgroundColor: '#999',
			width: 1 + Ti.App.units,
			top: 60 + Ti.App.units,
			height: 41 + Ti.App.units,
			left: left + Ti.App.units,
		});
		w.add(right_bar);
		left = left + 2;
	}
}
w.add(top_buttons);
//End Top Filter Buttons

function clearlabels(label_selected) {
	for(var i = 0; i < top_buttons.children.length; i++) {
		if(label_selected.children[0].node_id != top_buttons.children[i].children[0].node_id) top_buttons.children[i].children[0].color = "#000000";
	}
}

// create table view
var tableview = Titanium.UI.createTableView({
	data: data,
	top: 110 + Ti.App.units,
	backgroundColor: '#fff'
});
w.add(tableview);

// create table view event listener
tableview.addEventListener('click', function(e) {
	createWindow(e);
});

function createWindow(e) {
	var detail = Ti.UI.createWindow({
		url: '/windows/detail.js',
		backgroundColor: '#fff',
		navBarHidden: true,
		eventparam: e.rowData.node_id
	});
	detail.open({
		animated: true
	});
}

w.addEventListener('android:back', function() {
	closewindow();
});

function closewindow() {
	w.close();

	w = null;
}