Titanium.include('/db/db.js');

var w = Titanium.UI.currentWindow;

w.setBackgroundColor('#fff');
w.setTitle(L(Ti.App.locale + "_search_by_map"));

w.orientationModes = [Titanium.UI.PORTRAIT];
//Set dimensions of window
var pWidth = Ti.Platform.displayCaps.platformWidth;
var pHeight = Ti.Platform.displayCaps.platformHeight;
if(pWidth > pHeight) {
	pWidth = Ti.Platform.displayCaps.platformHeight;
	pHeight = Ti.Platform.displayCaps.platformWidth;
}

//Start TOP-BAR
var topbar = Titanium.UI.createView({
	backgroundColor: '#000',
	backgroundImage: '/images/bg_header.gif',
	top: 0 + Ti.App.units,
	width: pWidth,
	height: 36 + Ti.App.units
});
var logo_mhcat = Titanium.UI.createImageView({
	image: '/images/logo_mhcat.png',
	height: 24 + Ti.App.units,
	width: 24 + Ti.App.units,
	top: 5 + Ti.App.units,
	left: 5 + Ti.App.units
});
var title = Titanium.UI.createLabel({
	color: '#FFF',
	text: L(Ti.App.locale + "_search_by_map"),
	font: {
		fontSize: 16 + Ti.App.units,
		fontFamily: 'Arial'
	},
	left: 34 + Ti.App.units
});
var button_close = Titanium.UI.createButton({
	height: 31 + Ti.App.units,
	width: 32 + Ti.App.units,
	backgroundImage: '/images/bt_close.png',
	top: 2 + Ti.App.units,
	right: 0 + Ti.App.units
});

topbar.add(logo_mhcat);
topbar.add(title);
topbar.add(button_close);

w.add(topbar);
button_close.addEventListener('click', function(e) {
	closewindow();
});
//End TOP-BAR
//Start MAP
// CREATE ANNOTATIONS
var ico_image = 'ico_map_point_blue.png';
switch(Titanium.Platform.displayCaps.density) {
case 'normal':
	ico_image = 'ico_map_point_blue.png';
	break;
case 'high':
	ico_image = 'ico_map_point_blue_big.png';
	break;
case 'xhigh':
	ico_image = 'ico_map_point_blue_big.png';
	break;
}

var des_latitude = 0;
var des_longitude = 0;

var annotations = [];
var result = new ConfigReader().readMonumentsForMap();
var location = [];
for(var i = 0; i < result.length; i++) {
	var bubble = Ti.UI.createView({
		width: 200 + Ti.App.units
	});
	var myLbl = Ti.UI.createLabel({
		text: result[i].name,
		myid: result[i].node_id,
		left: 5 + Ti.App.units,
		height: 'auto',
		width: 200 + Ti.App.units,
		color: 'white',
		top: 5 + Ti.App.units,
		font: {
			fontSize: 16 + Ti.App.units,
			fontFamily: 'Arial'
		}
	});
	myLbl.addEventListener('click', function(e) {
		var detail = Ti.UI.createWindow({
			url: '/windows/detail.js',
			backgroundColor: '#fff',
			navBarHidden: true,
			eventparam: e.source.myid
		});
		detail.open({
			animated: true
		});
		closewindow();
	});

	var lbl_img = myLbl.toImage();

	var gotomon = Ti.UI.createView({
		right: 1 + Ti.App.units,
		myid: result[i].node_id,
		width: 31 + Ti.App.units,
		height: 32 + Ti.App.units,
		backgroundImage: '/images/rightandroidbutton.png'
	});
	gotomon.addEventListener('click', function(e) {
		var detail = Ti.UI.createWindow({
			url: '/windows/detail.js',
			backgroundColor: '#fff',
			navBarHidden: true,
			eventparam: e.source.myid
		});
		detail.open({
			animated: true
		});
		closewindow();
	});

	var button_arrive = Ti.UI.createView({
		title: 'button_arrive',
		width: 108 + Ti.App.units,
		height: 20 + Ti.App.units,
		top: lbl_img.height + 10 + Ti.App.units,
		left: 5 + Ti.App.units,
		myid: result[i].node_id,
		backgroundImage: '/images/bg_info_button_small.png'
	});
	location = result[i].location.split(',');
	var label_arrive = Ti.UI.createLabel({
		text: L(Ti.App.locale + '_how_arrive'),
		latitude: location[0],
		longitude: location[1],
		color: 'white',
		top: 1 + Ti.App.units,
		myid: result[i].node_id,
		font: {
			fontSize: 12 + Ti.App.units,
			fontFamily: 'Arial'
		}
	});

	label_arrive.addEventListener('click', function(e) {
		Titanium.Geolocation.accuracy = Titanium.Geolocation.ACCURACY_HIGH;
		Titanium.Geolocation.distanceFilter = 10;
		Titanium.Geolocation.getCurrentPosition(function(e) {
			if(e.error) {
				var url = "http://maps.google.com/maps?daddr=" + label_arrive.latitude + "," + label_arrive.longitude;
			} else {
				var latitude = e.coords.latitude;
				var longitude = e.coords.longitude;
				var url = "http://maps.google.com/maps?saddr=" + latitude + "," + longitude + "&daddr=" + label_arrive.latitude + "," + label_arrive.longitude;
			}
			Ti.Platform.openURL(url);
		});
	});

	var bottom_space = Ti.UI.createView({
		width: 10 + Ti.App.units,
		height: 10 + Ti.App.units,
		top: lbl_img.height + 25 + Ti.App.units,
		right: 5 + Ti.App.units
	});

	button_arrive.add(label_arrive);
	bubble.add(myLbl);
	bubble.add(gotomon);
	bubble.add(button_arrive);
	bubble.add(bottom_space);

	annotations[i] = Titanium.Map.createAnnotation({
		latitude: location[0],
		longitude: location[1],
		leftView: bubble,
		image: '/images/' + ico_image,
		myid: result[i].node_id
	});
}
//alert(JSON.stringify(bubble));
// CREATE MAP VIEW
var mapview = Titanium.Map.createView({
	mapType: Titanium.Map.STANDARD_TYPE,
	region: {
		latitude: 41.631867,
		longitude: 1.804004,
		latitudeDelta: 2.654,
		longitudeDelta: 2.654
	},
	animate: true,
	regionFit: true,
	userLocation: true,
	annotations: annotations,
	top: 36 + Ti.App.units
});
w.add(mapview);

//End MAP
w.addEventListener('android:back', function() {
	closewindow();
});

function closewindow() {
	w.close({
		animated: true
	});
	topbar.remove(logo_mhcat);
	topbar.remove(title);
	topbar.remove(button_close);
	w.remove(topbar);
	w.remove(mapview);
	mapview = null;
	topbar = null;
	annotations = null;
	logo_mhcat = null;
	title = null;
	button_close = null;
	w = null;
}