Titanium.include('/db/db.js');

var w = Titanium.UI.currentWindow;

w.setBackgroundColor('#fff');
w.setTitle(L(Ti.App.locale+"_search_by_name"));

w.orientationModes = [Titanium.UI.PORTRAIT];

//Set dimensions of window
var pWidth = Ti.Platform.displayCaps.platformWidth;
var pHeight = Ti.Platform.displayCaps.platformHeight;
if(pWidth > pHeight) {
	pWidth = Ti.Platform.displayCaps.platformHeight;
	pHeight = Ti.Platform.displayCaps.platformWidth;
}

var height_row = 40;
switch(Titanium.Platform.displayCaps.density) {
case 'normal':
	height_row = 40;
	break;
case 'high':
	height_row = 60;
	break;
case 'xhigh':
	height_row = 80;
	break;
}

//Start TOP-BAR
var topbar = Titanium.UI.createView({
   backgroundColor:'#000',
   backgroundImage:'/images/bg_header.gif',
   top:0 + Ti.App.units,
   width:pWidth,
   height: 36 + Ti.App.units
});
var logo_mhcat = Titanium.UI.createImageView({
	image:'/images/logo_mhcat.png',
	height: 24 + Ti.App.units,
	width: 24 + Ti.App.units,
	top: 5 + Ti.App.units,
	left: 5 + Ti.App.units
});
var title = Titanium.UI.createLabel({
	color:'#FFF',
	text:L(Ti.App.locale+"_search_the_monument_by_name"),
	font:{fontSize:16 + Ti.App.units , fontFamily:'Arial'},
	left: 34 + Ti.App.units
});
var button_close = Titanium.UI.createButton({
	height: 31 + Ti.App.units,
	width: 32 + Ti.App.units,
	backgroundImage:'/images/bt_close.png',
	top: 2 + Ti.App.units,
	right: 0 + Ti.App.units
});

topbar.add(logo_mhcat);
topbar.add(title);
topbar.add(button_close);

w.add(topbar);
//End TOP-BAR

//Start Search
var search = Titanium.UI.createSearchBar({
	barColor:'#000',
	showCancel:true,
	height: 43 + Ti.App.units,
	top: 34 + Ti.App.units
});
w.add(search);
var new_data = [];
search.value = L(Ti.App.locale+"_search")+'...';
search.addEventListener('focus', function(e){
	if(search.value == L(Ti.App.locale+"_search")+'...'){
		search.value = '';
	}
});
search.addEventListener('blur', function(e){
	if(search != null){
		if(search.value == ''){
			search.value = L(Ti.App.locale+"_search")+'...';
		}
	}
});
search.addEventListener('cancel', function(e){
	search.value = '';
});
search.addEventListener('return', function(e){
	new_data = [];
    var new_result = new ConfigReader().doSearch(e.value);
	for (var i=0; i<new_result.length; i++){
		new_data[i] = {title:new_result[i].name, node_id:new_result[i].node_id, color:'#000', selectedColor:'#fff', hasChild:true, font: { fontSize: 14 + Ti.App.units }}
	}
	tableview.data = new_data;
});
search.addEventListener('change', function(e)
{
   if (search.value.length > 2 && search.value != L(Ti.App.locale+"_search")+'...')
   {
   		new_data = [];
   		var new_result = new ConfigReader().doSearch(search.value);
		for (var i=0; i<new_result.length; i++){
			new_data[i] = {title:new_result[i].name, node_id:new_result[i].node_id, color:'#000', selectedColor:'#fff', hasChild:true, font: { fontSize: 14 + Ti.App.units }}
		}
		tableview.data = new_data;
   }else{
		tableview.data = data;
   }
   return false;
});
//End Search

var result = new ConfigReader().readAvailableMonuments();
var data = [];
for (var i=0; i<result.length; i++){
	data[i] = {title:result[i].name, node_id:result[i].node_id, color:'#000', selectedColor:'#fff', hasChild:true, font: { fontSize: 14 + Ti.App.units }, height: height_row}
}
// create table view
var tableview = Titanium.UI.createTableView({
	data:data,
	top: 73 + Ti.App.units,
	backgroundColor:'#fff'
});
w.add(tableview);

// create table view event listener
tableview.addEventListener('click', function(e){
	createWindow(e);
});

function createWindow(e){
	var detail = Ti.UI.createWindow({
		url:'/windows/detail.js',
		backgroundColor:'#fff',
		navBarHidden : true,
		eventparam:e.rowData.node_id
	});
	detail.open({animated: true});
}

function closewindow(){
	w.close({animated:true});
	topbar.remove(logo_mhcat);
	topbar.remove(title);
	topbar.remove(button_close);
	w.remove(topbar);
	w.remove(tableview);
	w.remove(search);
	topbar = null;
	logo_mhcat = null;
	title = null;
	button_close = null;
	search = null;
	result = null;
	w = null;
}

button_close.addEventListener('click', function(e){
	closewindow();
});

w.addEventListener('android:back', function(){closewindow();});